// AcqDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "AcqDlg.h"
#include "Bkdoc.h"
#include "Tektro.h"
#include "Regres.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CAcqDlg dialog
CAcqDlg::CAcqDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAcqDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAcqDlg)
	m_sTexte = _T("");
	m_radioTypeOscillo = -1;
	m_OKRef1 = FALSE;
	m_OKRef2 = FALSE;
	m_OKVoie1 = FALSE;
	m_OKVoie2 = FALSE;
	m_OKMath = FALSE;
	m_OkPara = FALSE;
	//}}AFX_DATA_INIT
}
void CAcqDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAcqDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDACQUERIR, m_btnAcq);
	DDX_Text(pDX, IDC_STATIC_INFO_ACQ, m_sTexte);
	DDX_Radio(pDX, IDC_TYPE0, m_radioTypeOscillo);
	DDX_Check(pDX, IDC_REF1, m_OKRef1);
	DDX_Check(pDX, IDC_REF2, m_OKRef2);
	DDX_Check(pDX, IDC_VOIE1, m_OKVoie1);
	DDX_Check(pDX, IDC_VOIE2, m_OKVoie2);
	DDX_Check(pDX, IDC_MATH, m_OKMath);
	DDX_Check(pDX, IDC_PARA, m_OkPara);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAcqDlg, CDialog)
	//{{AFX_MSG_MAP(CAcqDlg)
	ON_BN_CLICKED(IDACQUERIR, OnAcquerir)
	ON_BN_CLICKED(IDC_REF1, OnRef1)
	ON_BN_CLICKED(IDC_REF2, OnRef2)
	ON_BN_CLICKED(IDC_VOIE1, OnVoie1)
	ON_BN_CLICKED(IDC_VOIE2, OnVoie2)
	ON_BN_CLICKED(IDC_MATH, OnMath)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CAcqDlg message handlers
void CAcqDlg::GestionBoutons(void)
{
	short nb=0;
	GetDlgItem(IDC_VOIE1)->EnableWindow(TRUE);         
	GetDlgItem(IDC_VOIE2)->EnableWindow(TRUE);         
	GetDlgItem(IDC_REF1)->EnableWindow(TRUE);         
	GetDlgItem(IDC_REF2)->EnableWindow(TRUE);         
	GetDlgItem(IDC_MATH)->EnableWindow(TRUE);         
	if (m_OKVoie1) nb++;
	if (m_OKVoie2) nb++;
	if (m_OKRef1) nb++;
	if (m_OKRef2) nb++;
	if (m_OKMath) nb++;
	if (nb>1)
	{
		if (!m_OKVoie1) GetDlgItem(IDC_VOIE1)->EnableWindow(FALSE);
		if (!m_OKVoie2) GetDlgItem(IDC_VOIE2)->EnableWindow(FALSE);
		if (!m_OKRef1) GetDlgItem(IDC_REF1)->EnableWindow(FALSE);
		if (!m_OKRef2) GetDlgItem(IDC_REF2)->EnableWindow(FALSE);
		if (!m_OKMath) GetDlgItem(IDC_MATH)->EnableWindow(FALSE);
	}
	if (!m_OKVoie1 && !m_OKVoie2 && !m_OKRef1 && !m_OKRef2 && !m_OKMath)	
		m_btnAcq.EnableWindow(FALSE);
	else
	if (m_ok)
		m_btnAcq.EnableWindow(TRUE);
}
//________________________________________
BOOL CAcqDlg::AffectationTableau(char col1,char col2)
{
	BOOL ok=TRUE;
	short k,i,j;
	int curv;
	char
		c,s[30];
	//AfxMessageBox(m_pTektro->m_cBuf);
	i=0;j=0;m_pDoc->m_iNb=0;
	while (i<m_pTektro->m_sBuf.GetLength())
	{
		c=m_pTektro->m_sBuf.GetAt(i);
		if (c!=',')
		{
			s[j]=c;
			j++;
		} 
		else
		{
			//Extraction et affectation tableau
			s[j]='\0';
		 	k=sscanf(s,"%d",&curv);
 			if (k==1 && m_pDoc->m_iNb<m_pDoc->m_iNbMax)
 			{
 				m_pDoc->m_fT[m_pDoc->m_iNb][col1]=m_pDoc->m_iNb;
 				m_pDoc->m_fT[m_pDoc->m_iNb][col2]=curv;
				m_pDoc->m_fT[m_pDoc->m_iNb][col1]=m_pTektro->m_xincr*m_pDoc->m_fT[m_pDoc->m_iNb][col1]-m_pTektro->m_xincr*m_pTektro->m_pt_off;
				m_pDoc->m_fT[m_pDoc->m_iNb][col2]=m_pTektro->m_yzero+m_pTektro->m_ymult*(m_pDoc->m_fT[m_pDoc->m_iNb][col2]-m_pTektro->m_yoff);
				m_pDoc->m_iNb++;
				j=0;
			}
		}
		i++;
	}
	if (m_pDoc->m_iNb>m_pDoc->m_iNbMax-1)
	{
		//Dpassement taille tableau
		m_pDoc->m_iNb=0;
		ok=FALSE;
		AfxMessageBox("Dpassement taille tableau m_fT");
	}
	return ok;
}
//________________________________________
BOOL CAcqDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString s;
	//Informations concernant l'acquisition
	m_pDoc->m_sTab.RemoveAll();
	m_pDoc->m_sTab.Add("ACQ. OSCILLOSCOPE TEKTRONIX");
	m_pDoc->m_sTab.Add("Nom(s)/Prnom(s):");
	m_pTektro=new CTektro(m_pDoc->m_radioPortSerie);

	if (m_pDoc->m_iTypeAcq&1) m_OKVoie1=TRUE;
	if (m_pDoc->m_iTypeAcq&2) m_OKVoie2=TRUE;
	if (m_pDoc->m_iTypeAcq&4) m_OKRef1=TRUE;
	if (m_pDoc->m_iTypeAcq&8) m_OKRef2=TRUE;
	if (m_pDoc->m_iTypeAcq&16) m_OKMath=TRUE;
	m_sTexte="Slectionner les voies d'acquisition, puis cliquer sur Acqurir.";
	GestionBoutons();
	//Format des donnes et test criture sur port
	m_ok=m_pTektro->WriteCom("DATA:ENCDG ASCII\n");
	if (m_ok)
	{
		//Identification oscilloscope
		m_btnAcq.EnableWindow(FALSE);
		m_pTektro->WriteCom("RS232:PRESET\n");
		m_pTektro->WriteCom("ID?\n");
		m_iNb=0;SetTimer(1,10,NULL);
	}
	else
	{
		m_sTexte.Format("Erreur d'criture sur le port srie n%d !",m_pDoc->m_radioPortSerie+1);
		m_btnAcq.EnableWindow(FALSE);

	}
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CAcqDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CAcqDlg::OnCancel() 
{
	delete m_pTektro;
	CDialog::OnCancel();
}
//________________________________________
void CAcqDlg::OnAcquerir() 
{
	BOOL ok;
	CString s,s1;
	UpdateData(TRUE);
	//Invalid...
	/*
	if (m_OkPara)
	{
		m_pDoc->m_OKinfo=TRUE;
	}
	*/
	m_btnCancel.EnableWindow(FALSE);
	m_btnAcq.EnableWindow(FALSE);
	GetDlgItem(IDC_VOIE1)->EnableWindow(FALSE);         
	GetDlgItem(IDC_VOIE2)->EnableWindow(FALSE);         
	GetDlgItem(IDC_REF1)->EnableWindow(FALSE);         
	GetDlgItem(IDC_REF2)->EnableWindow(FALSE);         
	GetDlgItem(IDC_MATH)->EnableWindow(FALSE);         
	GetDlgItem(IDC_TYPE0)->EnableWindow(FALSE);         
	GetDlgItem(IDC_TYPE1)->EnableWindow(FALSE);         
	GetDlgItem(IDC_PARA)->EnableWindow(FALSE);         
	//En fonction de la voie d'acquisition...
	m_pDoc->m_iTypeGr=0;
	m_pDoc->m_iTypeAcq=0;
	m_iAcq=0;
	if (m_OKVoie1)
	{
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+1;
		m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+1;
		m_iAcq=m_iAcq+1;
	}
	if (m_OKVoie2)
	{
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+2;
		m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+2;
		m_iAcq=m_iAcq+2;
	}
	if (m_OKRef1)
	{
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+4;
		m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+4;
		m_iAcq=m_iAcq+4;
	}
	if (m_OKRef2)
	{
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+8;
		m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+8;
		m_iAcq=m_iAcq+8;
	}
	if (m_OKMath)
	{
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+16;
		m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+16;
		m_iAcq=m_iAcq+16;
	}

	m_iCol=0;
  //DATa:STARt
	m_pTektro->WriteCom("DATa:STARt 1\n");
	//DATa:STOP
	m_pTektro->WriteCom("DATa:STOP 2500\n");
	m_iNb=0;m_iLongBuf=0;SetTimer(0,10,NULL);
}
//________________________________________
void CAcqDlg::OnRef1() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//________________________________________
void CAcqDlg::OnRef2() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//________________________________________
void CAcqDlg::OnVoie1() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//________________________________________
void CAcqDlg::OnVoie2() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//________________________________________
void CAcqDlg::OnMath() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//________________________________________
void CAcqDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	int k[6];
	switch (nIDEvent)
	{
		case 0:
			//Dtermination voie
			KillTimer(0);
			if (m_iAcq==0)
			{
				//Les acquisitions sont termines
				m_sTexte.Format("Fin d'acquisition.\n%d valeurs crites dans le tableau.\n(%d)",m_pDoc->m_iNb+1,m_pTektro->m_sBuf.GetLength());
				m_btnCancel.EnableWindow(TRUE);
				m_btnAcq.EnableWindow(TRUE);
				GetDlgItem(IDC_VOIE1)->EnableWindow(TRUE);         
				GetDlgItem(IDC_VOIE2)->EnableWindow(TRUE);         
				GetDlgItem(IDC_REF1)->EnableWindow(TRUE);         
				GetDlgItem(IDC_REF2)->EnableWindow(TRUE);         
				GetDlgItem(IDC_MATH)->EnableWindow(TRUE);         
				GetDlgItem(IDC_TYPE0)->EnableWindow(TRUE);         
				GetDlgItem(IDC_TYPE1)->EnableWindow(TRUE);         
				GetDlgItem(IDC_PARA)->EnableWindow(TRUE);         
				GestionBoutons();
				UpdateData(FALSE);
				//On invalide le trac des rgressions
				m_pDoc->m_pReg->Invalider();
				m_pDoc->UpdateAllViews(NULL);
			}
			else
			if (m_iAcq&1)
			{
				//Voie 1
				m_iAcq=m_iAcq-1;
				m_sVoie="CH1";
				s.Format("SELect:CH1 ON\n");m_pTektro->WriteCom(s);
				s.Format("DATA:SOURCE CH1\n");m_pTektro->WriteCom(s);
				if(m_radioTypeOscillo==0)
					//Nouveau type, TDS 200 series, pas de n de voie  spcifier
					m_s="";
				else
					//Ancien type, TDS 310, n de voie  spcifier
					m_s="CH1:";
	 			//NR_PT, PT_Off, XINcr, YMULt
				s.Format("WFMPre:%sNR_Pt?\nWFMPre:%sPT_Off?\nWFMPre:%sXINcr?\nWFMPre:%sYMULt?\n",m_s,m_s,m_s,m_s);
				m_pTektro->WriteCom(s);
	 			//YZERo, YOFf
				s.Format("WFMPre:%sYZERo?\nWFMPre:%sYOFf?\n",m_s,m_s);
				m_pTektro->WriteCom(s);
				//Paramtres complmentaires -> Invalid...
				/*
				s.Format("MEASUrement:IMMed:SOUrce CH1\nMEASUrement:IMMed:TYPe AMPLitude\nMEASUrement:IMMed:VALue?\n");
				m_pTektro->WriteCom(s);
				s.Format("MEASUrement:IMMed:SOUrce CH1\nMEASUrement:IMMed:TYPe FREQuency\nMEASUrement:IMMed:VALue?\n");
				m_pTektro->WriteCom(s);
				s.Format("MEASUrement:IMMed:SOUrce CH1\nMEASUrement:IMMed:TYPe CMEan\nMEASUrement:IMMed:VALue?\n");
				m_pTektro->WriteCom(s);
				s.Format("MEASUrement:IMMed:SOUrce CH1\nMEASUrement:IMMed:TYPe CMRs\nMEASUrement:IMMed:VALue?\n");
				m_pTektro->WriteCom(s);
				*/
				m_iNb=0;m_iLongBuf=0;m_pTektro->VideBuffer();SetTimer(2,10,NULL);
			}
			else
			if (m_iAcq&2)
			{
				//Voie 2
				m_sVoie="CH2";
				m_iAcq=m_iAcq-2;
				s.Format("SELect:CH2 ON\n");m_pTektro->WriteCom(s);
				s.Format("DATA:SOURCE CH2\n");m_pTektro->WriteCom(s);
				if(m_radioTypeOscillo==0)
					//Nouveau type, TDS 200 series, pas de n de voie  spcifier
					m_s="";
				else
					//Ancien type, TDS 310, n de voie  spcifier
					m_s="CH2:";
	 			//NR_PT, PT_Off, XINcr, YMULt
				s.Format("WFMPre:%sNR_Pt?\nWFMPre:%sPT_Off?\nWFMPre:%sXINcr?\nWFMPre:%sYMULt?\n",m_s,m_s,m_s,m_s);
				m_pTektro->WriteCom(s);
	 			//YZERo, YOFf
				s.Format("WFMPre:%sYZERo?\nWFMPre:%sYOFf?\n",m_s,m_s);
				m_pTektro->WriteCom(s);
				m_iNb=0;m_iLongBuf=0;m_pTektro->VideBuffer();SetTimer(2,10,NULL);
			}
			else
			if (m_iAcq&4)
			{
				//REF1
				m_sVoie="REF1";
				m_iAcq=m_iAcq-4;
				s.Format("SELect:REF1 ON\n");m_pTektro->WriteCom(s);
				s.Format("DATA:SOURCE REF1\n");m_pTektro->WriteCom(s);
				if(m_radioTypeOscillo==0)
					//Nouveau type, TDS 200 series, pas de n de voie  spcifier
					m_s="";
				else
					//Ancien type, TDS 310, n de voie  spcifier
					m_s="REF1:";
	 			//NR_PT, PT_Off, XINcr, YMULt
				s.Format("WFMPre:%sNR_Pt?\nWFMPre:%sPT_Off?\nWFMPre:%sXINcr?\nWFMPre:%sYMULt?\n",m_s,m_s,m_s,m_s);
				m_pTektro->WriteCom(s);
	 			//YZERo, YOFf
				s.Format("WFMPre:%sYZERo?\nWFMPre:%sYOFf?\n",m_s,m_s);
				m_pTektro->WriteCom(s);
				m_iNb=0;m_iLongBuf=0;m_pTektro->VideBuffer();SetTimer(2,10,NULL);
			}
			else
			if (m_iAcq&8)
			{
				//REF2
				m_sVoie="REF2";
				m_iAcq=m_iAcq-8;
				s.Format("SELect:REF2 ON\n");m_pTektro->WriteCom(s);
				s.Format("DATA:SOURCE REF2\n");m_pTektro->WriteCom(s);
				if(m_radioTypeOscillo==0)
					//Nouveau type, TDS 200 series, pas de n de voie  spcifier
					m_s="";
				else
					//Ancien type, TDS 310, n de voie  spcifier
					m_s="REF2:";
	 			//NR_PT, PT_Off, XINcr, YMULt
				s.Format("WFMPre:%sNR_Pt?\nWFMPre:%sPT_Off?\nWFMPre:%sXINcr?\nWFMPre:%sYMULt?\n",m_s,m_s,m_s,m_s);
				m_pTektro->WriteCom(s);
	 			//YZERo, YOFf
				s.Format("WFMPre:%sYZERo?\nWFMPre:%sYOFf?\n",m_s,m_s);
				m_pTektro->WriteCom(s);
				m_iNb=0;m_iLongBuf=0;m_pTektro->VideBuffer();SetTimer(2,10,NULL);
			}
			else
			if (m_iAcq&16)
			{
				//MATH
				m_sVoie="MATH";
				m_iAcq=m_iAcq-16;
				s.Format("SELect:MATH ON\n");m_pTektro->WriteCom(s);
				s.Format("DATA:SOURCE MATH\n");m_pTektro->WriteCom(s);
				if(m_radioTypeOscillo==0)
					//Nouveau type, TDS 200 series, pas de n de voie  spcifier
					m_s="";
				else
					//Ancien type, TDS 310, n de voie  spcifier
					m_s="MATH:";
	 			//NR_PT, PT_Off, XINcr, YMULt
				s.Format("WFMPre:%sNR_Pt?\nWFMPre:%sPT_Off?\nWFMPre:%sXINcr?\nWFMPre:%sYMULt?\n",m_s,m_s,m_s,m_s);
				m_pTektro->WriteCom(s);
	 			//YZERo, YOFf
				s.Format("WFMPre:%sYZERo?\nWFMPre:%sYOFf?\n",m_s,m_s);
				m_pTektro->WriteCom(s);
				m_iNb=0;m_iLongBuf=0;m_pTektro->VideBuffer();SetTimer(2,10,NULL);
			}
		break;
		case 1://Identification
			if (m_iLongBuf<m_pTektro->m_sBuf.GetLength())
			{
				//L'acquisition est en cours, on attend
				m_iLongBuf=m_pTektro->m_sBuf.GetLength();
				m_iNb=0;
			}
			else
			{
				m_iNb++;
				if (m_iNb>20)//200 ms
				{
					KillTimer(1);
					//On lit le buffer
					s=m_pTektro->ReadBuf();
					if (s.IsEmpty())
					{
						m_radioTypeOscillo=-1;
						m_sTexte="Erreur de communication avec oscilloscope Tektronix !";
						m_btnAcq.EnableWindow(FALSE);
					}
					else
					{
						if (strstr(s,"TDS 3")) m_radioTypeOscillo=1; else m_radioTypeOscillo=0;
						m_pTektro->VideBuffer();m_iLongBuf=0;
						m_btnAcq.EnableWindow(TRUE);
					}
				}
			}
			UpdateData(FALSE);
		break;
		case 2://Paramtres
			if (m_iLongBuf<m_pTektro->m_sBuf.GetLength())
			{
				//L'acquisition est en cours, on attend
				m_iLongBuf=m_pTektro->m_sBuf.GetLength();
				m_iNb=0;
			}
			else
			{
				m_iNb++;
				if (m_iNb>50)
				{
					KillTimer(2);
					//On lit le buffer
					s=m_pTektro->ReadBuf();
					//AfxMessageBox(s);
					k[0]=sscanf(s,"%d",&(m_pTektro->m_nr_pt));
					s=m_pTektro->ReadBuf();
					//AfxMessageBox(s);
					k[1]=sscanf(s,"%d",&(m_pTektro->m_pt_off));
					s=m_pTektro->ReadBuf();
					//AfxMessageBox(s);
					k[2]=sscanf(s,"%e",&(m_pTektro->m_xincr));
					s=m_pTektro->ReadBuf();
					//AfxMessageBox(s);
					k[3]=sscanf(s,"%e",&(m_pTektro->m_ymult));
					s=m_pTektro->ReadBuf();
					//AfxMessageBox(s);
					k[4]=sscanf(s,"%e",&(m_pTektro->m_yzero));
					s=m_pTektro->ReadBuf();
					//AfxMessageBox(s);
					k[5]=sscanf(s,"%e",&(m_pTektro->m_yoff));
					if (k[0]==1 && k[1]==1 && k[2]==1 && k[3]==1 && k[4]==1 && k[5]==1)
					{
						m_sTexte.Format("Acquisition en cours: %s\nNR_Pt: %d, PT_Off: %d, XINCr: %1.1e, YMUlt: %1.1e, YZEro: %1.1e, YOFf: %1.1e",m_sVoie,m_pTektro->m_nr_pt,m_pTektro->m_pt_off,m_pTektro->m_xincr,m_pTektro->m_ymult,m_pTektro->m_yzero,m_pTektro->m_yoff);
						UpdateData(FALSE);
						//Curve
						m_iNb=0;m_iLongBuf=0;m_pTektro->VideBuffer();
						m_pTektro->WriteCom("CURVe?\n");
						SetTimer(3,10,NULL);
					}
					else
					{
						m_sTexte.Format("Erreur de lecture paramtres !");
						m_btnCancel.EnableWindow(TRUE);
						UpdateData(FALSE);
					}
				}
			}
		break;
		case 3://Curve
			if (m_iLongBuf<m_pTektro->m_sBuf.GetLength())
			{
				//L'acquisition est en cours, on attend
				m_iLongBuf=m_pTektro->m_sBuf.GetLength();
				m_iNb=0;
			}
			else
			{
				m_iNb++;
				if (m_iNb>20)
				{
					KillTimer(3);
					//On lit le buffer
					AffectationTableau(m_iCol,m_iCol+1);
					m_iCol=m_iCol+2;
					SetTimer(0,10,NULL);
				}
			}
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
