// BkDoc.cpp : implementation of the CBkDoc class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "Demardlg.h"
#include "Regres.h"
#include "Vicdefs.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkDoc
IMPLEMENT_DYNCREATE(CBkDoc, CDocument)

BEGIN_MESSAGE_MAP(CBkDoc, CDocument)
	//{{AFX_MSG_MAP(CBkDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CBkDoc construction/destruction
CBkDoc::CBkDoc()
{
	m_pApp=(CBkApp*)AfxGetApp();
	m_pApp->m_pDoc=this;
	//Nom fichiers par dfaut
	m_sNomFic="SansNom.cod";
	m_sNomFicTxt="SansNom.cod";
	//Limites
	m_fXmi=0;
	m_fYmi=0;
	m_fXma=270;
	m_fYma=190;
	//Dcalage d'origine, chelles et facteurs d'chelle
	m_fXori=0;
	m_fYori=0;
	m_fEchx=1;
	m_fEchy=1;
	m_fFactx=1;
	m_fFacty=1; 
	//Textes
	//m_fHautTexte=4.5;
	//m_fCoefTexte=1.0;
	//Port srie
	m_radioPortSerie=0;	//COM1 par dfaut pour oscillo
	m_radioCom=0;				//COM2 par dfaut pour Leuze
	//Voies d'acquisition
  m_iTypeAcq=1;			//1:CH1, 2:CH2, 4:REF1, 8:REF2, 16:MATH
	//Acquisition
  m_iNbMax=5000;		//5000 acquisitions maxi
  m_iNb=0;					//Aucune acquisition de faite pour l'instant
  m_fT=new float[m_iNbMax][6];
	//Initialisation tableau
	short i,j;
	for (i=0;i<m_iNbMax;i++)
	{
		for (j=0;j<6;j++)
		{
			m_fT[i][j]=1e10;
		}
	}
	//Rgressions polynomiales______________
	m_pReg=new CRegres();
	m_OKReg=FALSE;
	//Zoom et tracker_______________________
	m_OKZoom=FALSE;
	InitZoom();
	m_tracker.m_rect.left=0;
	m_tracker.m_rect.top=0;
	m_tracker.m_rect.right=1;
	m_tracker.m_rect.bottom=1;
	//Graphes_______________________________
	m_iTypeGr=0;	//(0:CODE , 1:CH1, 2:CH2, 4:REF1, 8:REF2, 16:MATH, 32:Image, 64: ?, 128: ?)
	//Infos zone de liste
	m_OKinfo=FALSE; 						//Affichage des infos par dfaut
	m_sTab.RemoveAll();
	m_sTab.Add("ACQ. OSCILLOSCOPE TEKTRONIX");
	m_sTab.Add("Nom(s)/Prnom(s):");
	m_fXinfo=80;							//Position d'criture par dfaut
	m_fYinfo=90;

	//Nom de fichier sur ligne de commande
  CWinApp *p=AfxGetApp();
  //AfxMessageBox(p->m_lpCmdLine);
	CString s1=p->m_lpCmdLine;
	s1.MakeLower();
	if (s1.Right(4)==".cod") 
	{
		m_sNomFic=s1;   
		//Lecture du fichier .tek
		OnOpenDocument(s1);
  }
	//Extraction code_______________________
	m_OKExCo=FALSE;
	//Paramtres code barre_________________
	m_fCoef=1.1;
	m_fEpaisT[0]=0.6;				//Epaisseur trait
	m_fEpaisE[0]=0.6;
	/*				//Epaisseur espace
	for (i=0;i<8;i++) 
	{
		m_lCb[i]=RGB(0,0,0);
		//m_lCb[i]=RGB(i*32,i*32,i*32);
		m_lCf[i]=RGB(255,255,255);
	}
	*/
	for (i=1;i<8;i++) 
	{
		m_fEpaisT[i]=m_fEpaisT[i-1]*m_fCoef;				//Epaisseur trait
		m_fEpaisE[i]=m_fEpaisT[i-1]*m_fCoef;				//Epaisseur espace
	}
	m_lCb[0]=RGB(64,0,0);m_lCf[0]=RGB(64,255,255);
	m_lCb[1]=RGB(0,0,255);m_lCf[1]=RGB(0,255,0);
	m_lCb[2]=RGB(0,255,255);m_lCf[2]=RGB(255,255,0);
	m_lCb[3]=RGB(255,0,0);m_lCf[3]=RGB(255,255,255);
	m_lCb[4]=RGB(255,0,0);m_lCf[4]=RGB(0,0,0);
	m_lCb[5]=RGB(64,64,64);m_lCf[5]=RGB(192,192,192);
	m_lCb[6]=RGB(128,128,128);m_lCf[6]=RGB(192,192,192);
	m_lCb[7]=RGB(0,0,0);m_lCf[7]=RGB(255,255,255);
	//Code barre par dfaut
	//m_sCode="0027131006534";	//Parfum Knowing
	//m_sCode="0028941648327";	//CD Mozart
	//m_sCode="3048431001545";	//Vittel
	//m_sCode="3414090816491";	//Dodorant
	//m_sCode="3278940919974";	//Protge slip
	//m_sCode="3527360009759";	//CD RW
	//m_sCode="3428271930050";	//Lait 1l
	//m_sCode="3365000005316";	//Starwax vitres
	//m_sCode="4005808650002";	//Stick  lvres
	//m_sCode="4007817504598";	//Gomme
	//m_sCode="4015400021155";	//Couches Frdric
	m_sCode="5410673004208";	//Riz Oncle Benz
	//m_sCode="5099703981421";	//CD Beethoven
	//m_sCode="8076802085837";	//Ptes Barilla
	//m_sCode="7610810992322";	//Dissolvant
	//Rotation code barres
	m_iRot=0;
	//Image Victor__________________________
	image=new imgdes;
	allocimage(image,768,576,24);
	zeroimage(255,image);
	//Taille________________________________
	m_iL=768;
	m_iH=576;
	m_iNbB=24;
	//Boite de dialogue au dmarrage________
	/*
	CDemarDlg* m_pDemDlg;
	m_pDemDlg=new CDemarDlg();
	Sleep(3000);
	delete m_pDemDlg;
	*/

	//Fichier bk.$$$________________________
	m_iNbCar=0;
	m_OKOuvert=FALSE;

}
//________________________________________
CBkDoc::~CBkDoc()
{
	freeimage(image);
	delete image;
	delete[] m_fT;
	delete m_pReg;
}
//________________________________________
BOOL CBkDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	CString s;
  //Suppression extension
  s=m_sNomFic.Mid(0,m_sNomFic.GetLength()-4);
  //Suppression chemin
  int i=s.GetLength();
  do
  {    
  	i--;
  }
  while (i>=0 && s.GetAt(i)!='\\' && s.GetAt(i)!=':');
  if (i!=0) s=s.Mid(i+1,s.GetLength());
	//En minuscules
	s.MakeLower();
	//1er caractre en majuscules
	s.SetAt(0,toupper(s.GetAt(0)));	
	SetTitle(s);
	return TRUE;
}
//________________________________________
// CBkDoc serialization
void CBkDoc::Serialize(CArchive& ar)
{
	float r;
	short i,j;
	CString s;
	if (ar.IsStoring())
	{
		//ECRITURE
		ar << m_sCode;
		ar << (short)m_iNbMax;
		ar << (short)m_iNb;           
		ar << (float)4.5;//Hauteur texte
		ar << (float)1.0;//Coef. texte
		ar <<	(short)m_iTypeGr;
		ar <<	(short)m_iTypeAcq;
		ar <<	m_fCoef;
		for (i=0;i<8;i++)
		{
			ar <<	m_lCb[i];
			ar <<	m_lCf[i];
			ar <<	m_fEpaisT[i];
			ar <<	m_fEpaisE[i];
		}
		for (i=0;i<m_iNb;i++)
		{
			ar << m_fT[i][0];
			ar << m_fT[i][1];
			ar << m_fT[i][2];
			ar << m_fT[i][3];
			ar << m_fT[i][4];
			ar << m_fT[i][5];
		}
		//Srialisation infos
		ar << (short)m_sTab.GetSize();
		for (i=0;i<m_sTab.GetSize();i++)
		{  
			ar << m_sTab.GetAt(i);
		}
		ar << m_fXinfo;
		ar << m_fYinfo;
		//Rgressions
		for (i=0;i<3;i++)
		{
			for (j=0;j<9;j++)
			{
				ar << m_pReg->m_fa[i][j];
			}
			for (j=0;j<2;j++)
			{
				ar << m_pReg->m_fP1[i][j];
				ar << m_pReg->m_fP2[i][j];
				ar << (short)m_pReg->m_iNoColX[i][j];
				ar << (short)m_pReg->m_iNoColY[i][j];
		 		ar << (short)m_pReg->m_iNoPt[i][j];
				ar << (short)m_pReg->m_OKPt[i][j];
			}
	 		ar << (short)m_pReg->m_iNoBtn[i];
			ar << (short)m_pReg->m_iType[i];
	 		ar << (short)m_pReg->m_OKCalcul[i];
	 		ar << (short)m_pReg->m_OKTrace[i];
		}
		//Autres paramtres
		ar <<	(short)i;
		ar <<	(short)i;
		ar <<	(short)i;
		ar <<	(short)i;
		ar <<	(short)i;
		ar << r;
		ar << r;
		ar << r;
		ar << r;
		ar << r;
	}
	else
	{
		//LECTURE
		//Pas de marque de pointage, pas de coordonnes relatives
		CBkApp* pApp=(CBkApp*)AfxGetApp();
		pApp->m_fDx=1e10;
		pApp->m_fDy=1e10;
		InitZoom();
		ar >> m_sCode;
		ar >> (short&)m_iNbMax;
		ar >> (short&)m_iNb;
		ar >> r;
		ar >> r;
		ar >>	(short&)m_iTypeGr;
		ar >>	(short&)m_iTypeAcq;
		ar >>	m_fCoef;
		for (i=0;i<8;i++)
		{
			ar >>	m_lCb[i];
			ar >>	m_lCf[i];
			ar >>	m_fEpaisT[i];
			ar >>	m_fEpaisE[i];
		}
    for (i=0;i<m_iNb;i++)
		{
			ar >> m_fT[i][0];
			ar >> m_fT[i][1];
			ar >> m_fT[i][2];
			ar >> m_fT[i][3];
			ar >> m_fT[i][4];
			ar >> m_fT[i][5];
		}                    
		//Srialisation infos  
		m_sTab.RemoveAll();
		ar >> (short&)j;
		for (i=0;i<j;i++)
		{  
			ar >>s; 
			m_sTab.Add(s);
		} 
		ar >> m_fXinfo;
		ar >> m_fYinfo;
		//Rgressions
		for (i=0;i<3;i++)
		{
			for (j=0;j<9;j++)
			{
				ar >> m_pReg->m_fa[i][j];
			}
			for (j=0;j<2;j++)
			{
				ar >> m_pReg->m_fP1[i][j];
				ar >> m_pReg->m_fP2[i][j];
				ar >> (short&)m_pReg->m_iNoColX[i][j];
				ar >> (short&)m_pReg->m_iNoColY[i][j];
		 		ar >> (short&)m_pReg->m_iNoPt[i][j];
				ar >> (short&)m_pReg->m_OKPt[i][j];
			}
	 		ar >> (short&)m_pReg->m_iNoBtn[i];
			ar >> (short&)m_pReg->m_iType[i];
	 		ar >> (short&)m_pReg->m_OKCalcul[i];
	 		ar >> (short&)m_pReg->m_OKTrace[i];
		}
		//Autres paramtres
		ar >>	(short&)i;
		ar >>	(short&)i;
		ar >>	(short&)i;
		ar >>	(short&)i;
		ar >>	(short&)i;
		ar >> r;
		ar >> r;
		ar >> r;
		ar >> r;
		ar >> r;
	}	
}
//________________________________________
// CBkDoc diagnostics
#ifdef _DEBUG
void CBkDoc::AssertValid() const
{
	CDocument::AssertValid();
}
void CBkDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
//________________________________________
// CBkDoc commands
void CBkDoc::ColonnesTableau(short NoGr, short *ColT,short *ColU)
{
	//Recherche des colonnes t(s) et u(V) du tableau
	switch (NoGr)
	{
		case 1://CH1
			*ColT=0;*ColU=1;
		break;
		case 2://CH2
			if (m_iTypeAcq & 1)
			{
				*ColT=2;*ColU=3;
			}
			else
			{
				*ColT=0;*ColU=1;
			}
		break;
		case 4://REF1
			if ((m_iTypeAcq & 1) || (m_iTypeAcq & 2))
			{
				*ColT=2;*ColU=3;
			}
			else
			{
				*ColT=0;*ColU=1;
			}
		break;
		case 8://REF2
			if ((m_iTypeAcq & 1) || (m_iTypeAcq & 2)|| (m_iTypeAcq & 4))
			{
				*ColT=2;*ColU=3;
			}
			else
			{
				*ColT=0;*ColU=1;
			}
		break;
		case 16://MATH
			if ((m_iTypeAcq & 1) || (m_iTypeAcq & 2)|| (m_iTypeAcq & 4)|| (m_iTypeAcq & 8))
			{
				*ColT=2;*ColU=3;
			}
			else
			{
				*ColT=0;*ColU=1;
			}
		break;
		default://Autres
			*ColT=4;*ColU=5;
		break;
	}
}
//________________________________________
void CBkDoc::InitZoom(void)
{                       
	m_fZoomXmi=-1e10;
	m_fZoomXma=1e10;
	m_fZoomYmi=-1e10;
	m_fZoomYma=1e10;
}
//________________________________________
void CBkDoc::Zoom(float xmi,float ymi,float xma,float yma)
{                       
	float r;
	if (xmi>xma)
	{
		r=xmi;
		xmi=xma;
		xma=r;
	}
	if (ymi>yma)
	{
		r=ymi;
		ymi=yma;
		yma=r;
	}
	m_fZoomXmi=xmi;
	m_fZoomXma=xma;
	m_fZoomYmi=ymi;
	m_fZoomYma=yma;
}
//________________________________________
//________________________________________
//________________________________________
CString CBkDoc::Renvoie_buffer(void)
{
	//Analyse du contenu du fichier bk.$$$
	short 
		i;
	CString s;
	unsigned char C[1];

	s.Format("%1000s"," ");
	//On regarde si le fichier bk.$$$ existe, si oui on l'analyse
	BOOL 
		ok;
	CFileException p_Error;
	ok=m_Fic.Open("bk.$$$",CFile::modeRead,&p_Error);
	if (ok)
	{
		//Taille du fichier
		m_iNbCar=m_Fic.GetLength();
		//s.Format("%d",m_iNbCar);AfxMessageBox(s);
		m_iNb=0;
		for (i=0;i<m_iNbCar;i++)
		{
			m_Fic.Read(C,1);
			if (i<999)
			{
				s.SetAt(i,C[0]);
				s.SetAt(i+1,'\0');
			}
		}
		if (m_iNbCar==0) s="";
		//AfxMessageBox(s);
		m_Fic.Close();
	}
	else
		s="";
	return s;
}