// BkView.cpp : implementation of the CBkView class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "BkView.h"
#include "porsedlg.h"
#include "porse1dlg.h"
#include "tektro.h"
#include "acqdlg.h"
#include "acq1dlg.h"
#include "dessin.h"
#include "gradlg.h"
#include "regdlg.h"
#include "infodlg.h"
#include "regres.h"
#include "zoomdlg.h"
#include "excodlg.h"
#include "gecodlg.h"
#include "paradlg.h"
#include "code.h"
#include "rotdlg.h"
#include "anadlg.h"
#include "seriedlg.h"
#include "leleudlg.h"
#include "eurodlg.h"
#include "lasdlg.h"
#include "vicdefs.h"
#include <sys/timeb.h>
#include <locale.h>
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CBkView
IMPLEMENT_DYNCREATE(CBkView, CView)

BEGIN_MESSAGE_MAP(CBkView, CView)
	//{{AFX_MSG_MAP(CBkView)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_CONNECTION, OnConnection)
	ON_COMMAND(ID_ACQUERIR, OnAcquerir)
	ON_UPDATE_COMMAND_UI(ID_SEL_GRAPHE, OnUpdateSelGraphe)
	ON_UPDATE_COMMAND_UI(ID_REGRESSION, OnUpdateRegression)
	ON_COMMAND(ID_LEGENDE, OnLegende)
	ON_UPDATE_COMMAND_UI(ID_TXT, OnUpdateTxt)
	ON_COMMAND(ID_TXT, OnTxt)
	ON_COMMAND(ID_REGRESSION, OnRegression)
	ON_UPDATE_COMMAND_UI(ID_ZOOM, OnUpdateZoom)
	ON_WM_SETCURSOR()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_SEL_GRAPHE, OnSelGraphe)
	ON_COMMAND(ID_ZOOM, OnZoom)
	ON_UPDATE_COMMAND_UI(ID_EXTRACTION, OnUpdateExtraction)
	ON_COMMAND(ID_EXTRACTION, OnExtraction)
	ON_COMMAND(ID_GEN_EAN13, OnGenEan13)
	ON_COMMAND(ID_PARAMETRES, OnParametres)
	ON_UPDATE_COMMAND_UI(ID_ROTATIONCODE, OnUpdateRotationcode)
	ON_COMMAND(ID_ROTATIONCODE, OnRotationcode)
	ON_UPDATE_COMMAND_UI(ID_ANALYSE, OnUpdateAnalyse)
	ON_COMMAND(ID_ANALYSE, OnAnalyse)
	ON_COMMAND(ID_LECTEURLEUZE_CONNECTER, OnLecteurleuzeConnecter)
	ON_COMMAND(ID_LIRECODES, OnLirecodes)
	ON_COMMAND(ID_ACQ_EUROSMART, OnAcqEurosmart)
	ON_COMMAND(ID_LIRE_IMAGE, OnLireImage)
	ON_UPDATE_COMMAND_UI(ID_LEGENDE, OnUpdateLegende)
	ON_UPDATE_COMMAND_UI(ID_ACQ_EUROSMART, OnUpdateAcqEurosmart)
	ON_COMMAND(ID_CONNECTION1, OnConnection1)
	ON_COMMAND(ID_ACQ_INSTEK, OnAcqInstek)
	ON_UPDATE_COMMAND_UI(ID_GENRER_FAIS, OnUpdateGenrerFais)
	ON_COMMAND(ID_GENRER_FAIS, OnGenrerFais)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_COMMAND(ID__INIT_SOURIS,InitSouris)
	ON_COMMAND(ID__LEGENDE,OnDefinirLegende)
END_MESSAGE_MAP()
//////////////////////////////////////////
// CBkView construction/destruction
CBkView::CBkView()
{
	//Affichage coordonnes souris accroches au graphe
	m_iLig=-1;
	m_iCol=-1;
	m_iNo=-1;
	m_OK=FALSE;
}
CBkView::~CBkView()
{
}
BOOL CBkView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}
//________________________________________
void CBkView::MajZone(short x1,short y1,short x2,short y2) 
{
	class CBkDoc *pDoc=GetDocument();
	CRect rect1,rect2,rect3;
	short
		i=50,j=25;
	//Anciennes coordonnes
	rect1.left=x1-i;rect1.right=x1+i;rect1.top=y1-j;rect1.bottom=y1+5;
	//Nouvelles coordonnes
	rect2.left=x2-i;rect2.right=x2+i;rect2.top=y2-j;rect2.bottom=y2+5;
	rect3.UnionRect((LPCRECT)rect1,(LPCRECT)rect2);
	InvalidateRect(rect3,TRUE);
	pDoc->UpdateAllViews(this,(LPARAM)(LPCRECT)rect3);
}
//________________________________________
void CBkView::PIX_FEN(short xp,short yp,float *xmm,float *ymm) 
{
	//Changement de coordonnes Souris(pixels) -> Fentre
	class CBkDoc *pDoc=GetDocument();
	float 
		x,y,
		f_ech,f_echx,f_echy;
	CRect rect;

	GetClientRect(rect);
	f_echx=rect.right/(pDoc->m_fXma-pDoc->m_fXmi);
	f_echy=rect.bottom/(pDoc->m_fYma-pDoc->m_fYmi);
	//Calcul des coordonnes souris dans le repre du graphe
	if (f_echx<f_echy) 
		f_ech=f_echx; 
	else
		f_ech=f_echy;
	*xmm=pDoc->m_fXmi+xp/f_ech;
	*ymm=pDoc->m_fYma-yp/f_ech;
}
//________________________________________
void CBkView::FEN_GR(float xmm,float ymm,float *x,float *y) 
{
 	//Changement de coordonnes Fentre -> Graphe
	class CBkDoc *pDoc=GetDocument();
	*x=(xmm/pDoc->m_fEchx+pDoc->m_fXori)*pDoc->m_fFactx;
	*y=(ymm/pDoc->m_fEchy+pDoc->m_fYori)*pDoc->m_fFacty;
}
//________________________________________
void CBkView::GR_TAB(float x,float y,float *xt,float *yt) 
{
 	//Changement de coordonnes Graphe -> Tableau de mesures
	class CBkDoc *pDoc=GetDocument();
	*xt=x/pDoc->m_fFactx;
	*yt=y/pDoc->m_fFacty;
}
//________________________________________
void CBkView::TAB_GR(float xt,float yt,float *x,float *y) 
{
 	//Changement de coordonnes Tableau de mesures -> Graphe
	class CBkDoc *pDoc=GetDocument();
	*x=xt*pDoc->m_fFactx;
	*y=yt*pDoc->m_fFacty;
}
//________________________________________
void CBkView::GR_FEN(float x,float y,float *xmm,float *ymm) 
{
 	//Changement de coordonnes Graphe -> Fentre 
	class CBkDoc *pDoc=GetDocument();
	*xmm=(x/pDoc->m_fFactx-pDoc->m_fXori)*pDoc->m_fEchx;
	*ymm=(y/pDoc->m_fFacty-pDoc->m_fYori)*pDoc->m_fEchy;
}
//________________________________________
void CBkView::FEN_PIX(float xmm,float ymm,short *xp,short *yp) 
{
	//Changement de coordonnes Fentre -> Pixel (ex: Souris)
	class CBkDoc *pDoc=GetDocument();
	float 
		x,y,
		f_ech,f_echx,f_echy;
	CRect rect;

	GetClientRect(rect);
	f_echx=rect.right/(pDoc->m_fXma-pDoc->m_fXmi);
	f_echy=rect.bottom/(pDoc->m_fYma-pDoc->m_fYmi);
	//Calcul des coordonnes souris dans le repre du graphe
	if (f_echx<f_echy) 
		f_ech=f_echx; 
	else
		f_ech=f_echy;
	*xp=(xmm-pDoc->m_fXmi)*f_ech;
	*yp=(-ymm+pDoc->m_fYma)*f_ech;
}
//////////////////////////////////////////
// CBkView drawing
void CBkView::OnDraw(CDC* pDC)
{
	CBkDoc* pDoc=GetDocument();
	if (pDoc->m_iTypeGr==0)
	{
		DrawCode(pDC);
	}
	else
	if (pDoc->m_iTypeGr&32)
	{
		DrawImage(pDC);
	}
	else
	{
		DrawGraphe(pDC);
	}
}
//________________________________________
void CBkView::DrawImage(CDC *pDC)
{
	CBkDoc* pDoc=GetDocument();
	short i,j;
	float PI=4*atan(1),a,b,x,y;
	long w;

	HDC hDC;
	hDC=pDC->m_hDC;
	HPALETTE hpal;
	CSize size; 
	CPoint pt;
	CRect rect;
	int ech;
	if (pDC->IsPrinting())
	{
		pDC->SetMapMode(MM_ISOTROPIC) ;
		ech=3;
		pDC->DPtoLP(rect);            
		rect.BottomRight().x=rect.BottomRight().x*ech;
		rect.BottomRight().y=rect.BottomRight().y*ech;
		pDC->SetWindowExt(pDoc->m_iL,pDoc->m_iH);
		pDC->SetViewportExt(pDoc->m_iL*ech,pDoc->m_iH*ech);
	}
	else
	{
		pDC->DPtoLP(rect);            
	}
	//Visualisation image___________________
	viewimage(m_hWnd,hDC,&hpal,0,0,pDoc->image);
}
//________________________________________
void CBkView::DrawGraphe(CDC *pDC)
{
	CBkDoc* pDoc=GetDocument();
	CBkApp* pApp=(CBkApp*)AfxGetApp();
	float x,y,f_ech;
	if (pDoc->m_OKZoom || pDoc->m_OKExCo)
	{
		//Tracker_____________________________
		CPen 
		p,
		*m_pO;
		p.CreatePen(PS_DOT,1,RGB(127,127,255));
		m_pO=pDC->SelectObject(&p);        
		pDC->MoveTo(pDoc->m_tracker.m_rect.left,pDoc->m_tracker.m_rect.top);
		pDC->LineTo(pDoc->m_tracker.m_rect.right,pDoc->m_tracker.m_rect.top);
		pDC->LineTo(pDoc->m_tracker.m_rect.right,pDoc->m_tracker.m_rect.bottom);
		pDC->LineTo(pDoc->m_tracker.m_rect.left,pDoc->m_tracker.m_rect.bottom);
		pDC->LineTo(pDoc->m_tracker.m_rect.left,pDoc->m_tracker.m_rect.top);
		pDoc->m_tracker.Draw(pDC);
		pDC->SelectObject(m_pO);        
		p.DeleteObject();        
	}
	if (pDC->IsPrinting())
	{
		f_ech=FenetreImp(pDC,pDoc->m_fXmi,pDoc->m_fYmi,pDoc->m_fXma,pDoc->m_fYma);
		//Pas de marque de pointage
		pApp->m_fDx=1e10;
		pApp->m_fDy=1e10;
	}
	else
	{
		f_ech=Fenetre(pDC,pDoc->m_fXmi,pDoc->m_fYmi,pDoc->m_fXma,pDoc->m_fYma);
	}
	if (pDoc->m_iNb>0)
	{
		class CDessin *pDes;
		pDes=new CDessin(pDC);
		//Slection des graphes  visualiser
		short colT,colU;
		short n=0;
		if(pDoc->m_iTypeGr&1)
		{
			//CH1
			pDoc->ColonnesTableau(1,&colT,&colU);			
			pDes->Absisse(n,colT,"CH1:t(s)");
			pDes->Ordonnee(n,colU,"CH1:U(V)");
			n++;
		}
		if(pDoc->m_iTypeGr&2)
		{
			//CH2
			pDoc->ColonnesTableau(2,&colT,&colU);			
			pDes->Absisse(n,colT,"CH2:t(s)");
			pDes->Ordonnee(n,colU,"CH2:U(V)");
			n++;
		}
		if(pDoc->m_iTypeGr&4)
		{
			//REF1
			pDoc->ColonnesTableau(4,&colT,&colU);			
			pDes->Absisse(n,colT,"REF1:t(s)");
			pDes->Ordonnee(n,colU,"REF1:U(V)");
			n++;
		}
		if(pDoc->m_iTypeGr&8)
		{
			//REF2
			pDoc->ColonnesTableau(8,&colT,&colU);			
			pDes->Absisse(n,colT,"REF2:t(s)");
			pDes->Ordonnee(n,colU,"REF2:U(V)");
			n++;
		}
		if(pDoc->m_iTypeGr&16)
		{
			//MATH
			pDoc->ColonnesTableau(16,&colT,&colU);			
			pDes->Absisse(n,colT,"MATH:t(s)");
			pDes->Ordonnee(n,colU,"MATH");
			n++;
		}
		if(pDoc->m_iTypeGr&32)
		{
			//URef
			pDes->Absisse(n,4,"t(s)");
			pDes->Ordonnee(n,5,"U_Ref(V)");
			n++;
		}
		
		if(pDoc->m_iTypeGr&64)
		{
			//Fronts
			pDoc->ColonnesTableau(64,&colT,&colU);			
			pDes->Absisse(n,colT,"FRONTS:t(s)");
			pDes->Ordonnee(n,colU,"FRONTS:U(V)");
			n++;
		}
		
		if(pDoc->m_iTypeGr&128)
		{
			//Acq. Eurosmart
			pDes->Absisse(0,0,"N");
			pDes->Ordonnee(0,1,"Niv. logique");
		}
		
		//Zoom
		pDes->Zoom(pDoc->m_fZoomXmi,pDoc->m_fZoomYmi,pDoc->m_fZoomXma,pDoc->m_fZoomYma);
		//Trac du graphe; les limites de la fentre sont mises  jour par cette fonction (en gardant la taille larg x haut)!
		if(pDes->Graphe61()==0)
		{
		  //Ecriture des infos de CInfoDlg
 			if (pDoc->m_OKinfo) 
 			{
	 			pDes->ecritInfo(pDoc->m_fXinfo,pDoc->m_fYinfo,&(pDoc->m_sTab),RGB(0,0,255));	
 			}
			//Trac des rgressions
			for (short i=0;i<3;i++)
			{
				if (pDoc->m_pReg->m_OKTrace[i] && pDoc->m_pReg->m_OKCalcul[i])
				{
					if (pDoc->m_pReg->m_iType[i]==0)
					{
 					 	//Linaire
						pDes->TraceDMC(i,pDoc->m_pReg->m_fa[i][1],pDoc->m_pReg->m_fa[i][0]);
					}
					else
					{
						//Polynomiale
						pDes->TraceReg(i,pDoc->m_pReg);
					}
				 	pDes->TraceMarqPoint(pDoc->m_pReg->m_fP1[i][0],pDoc->m_pReg->m_fP1[i][1],pDoc->m_pReg->m_fP2[i][0],pDoc->m_pReg->m_fP2[i][1]);
				}
			}
			//Trac de la marque de pointage  la position de la souris
			if (pApp->m_fDx!=1e10 && pApp->m_fDy!=1e10)
			{                          
				x=pApp->m_fX;
				y=pApp->m_fY;
				if (m_OK)
					pDes->MarqueDePointageVal(RGB(0,0,255),x,y);
				else
					pDes->MarqueDePointageVal(RGB(0,0,0),x,y);
			}
		}
		delete pDes;
	}
}
//////////////////////////////////////////
// CBkView printing
BOOL CBkView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}
void CBkView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}
void CBkView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}
//////////////////////////////////////////
// CBkView diagnostics
#ifdef _DEBUG
void CBkView::AssertValid() const
{
	CView::AssertValid();
}
void CBkView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
CBkDoc* CBkView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBkDoc)));
	return (CBkDoc*)m_pDocument;
}
#endif //_DEBUG
//////////////////////////////////////////
// CBkView message handlers
//Menu contextuel_________________________
void CBkView::OnDefinirLegende() 
{
	CBkDoc* pDoc=GetDocument();
	CInfoDlg d;

	PIX_FEN(m_point.x,m_point.y,&(pDoc->m_fXinfo),&(pDoc->m_fYinfo));
	d.m_pDoc=pDoc;
	d.DoModal();
}
//________________________________________
void CBkView::InitSouris()
{
	//Initialisation coordonnnes relatives souris
	CBkApp* pApp=(CBkApp*)AfxGetApp();
	pApp->m_fDx=1e10;
	pApp->m_fDy=1e10;
	pApp->m_iDx=0;
	pApp->m_iDy=0;
	GetDocument()->UpdateAllViews(NULL);
}
//________________________________________
void CBkView::EcritureTxt(CString sFic, char Type)
{
	CString S,s[8];
	short i,j,k,n,n1;
	float x,y;
	BOOL ok;
	CFile fic;
	CFileException p_Error;
	CBkDoc* pDoc=GetDocument();
	
	for (i=0;i<8;i++) s[i]="";
	ok=fic.Open(sFic,CFile::modeWrite|CFile::modeCreate,&p_Error);
	if (!ok)
	{
		AfxMessageBox("Erreur d'ouverture du fichier en mode cration !");
	}
	else
	{
		if (Type==1)
		{
			S="CODE BARRES EAN13\r\n";
			fic.Write(S,S.GetLength());           
			if (pDoc->m_iTypeGr&1)
			{
				//CH1
				s[0]="CH1:t(s)\tCH1:U(V)\t";
			}
			if (pDoc->m_iTypeGr&2)
			{
				//CH1
				s[1]="CH2:t(s)\tCH2:U(V)\t";
			}
			if (pDoc->m_iTypeGr&4)
			{
				//REF1
				s[2]="REF1:t(s)\tREF1:U(V)\t";
			}
			if (pDoc->m_iTypeGr&8)
			{
				//REF2
				s[3]="REF2:t(s)\tREF2:U(V)\t";
			}
			if (pDoc->m_iTypeGr&16)
			{
				//MATH
				s[4]="MATH:t(s)\tMATH\t";
			}
			if (pDoc->m_iTypeGr&32)
			{
				s[5]=" \t \t";
			}
			if (pDoc->m_iTypeGr&64)
			{
				s[6]=" \t \t";
			}
			if (pDoc->m_iTypeGr&128)
			{
				s[7]=" \t \t";
			}
			S.Format("%s%s%s%s%s%s%s%s\r\n",s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
			fic.Write(S,S.GetLength());           
		}

		for (k=0;k<pDoc->m_iNbMax;k++)
		{
			n=1;n1=0;
			do
			{
				if (pDoc->m_iTypeGr&n)
				{
					pDoc->ColonnesTableau(n,&i,&j);
					x=pDoc->m_fT[k][i];y=pDoc->m_fT[k][j];
					if (x!=1e10 && y!=1e10)
					{
						s[n1].Format("%1.8e\t%1.8e\t",x,y);
					}
					else
					if (x==1e10 && y==1e10)
					{
						s[n1]="?\t ?\t";
					}
					else
					if (x!=1e10)
					{
						s[n1].Format("%1.8e\t?\t",x);
					}
					else
					{
						s[n1].Format("?\t%1.8e\t",y);
					}
				}	
				n=n*2;
				n1=n1+1;
			}
			while (n<=64 && n1<8);
			S.Format("%s%s%s%s%s%s%s%s\r\n",s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
			fic.Write(S,S.GetLength());           
		}
		fic.Close();
	}
}
//________________________________________
float CBkView::Fenetre(CDC* pDC,float f_xmi,float f_ymi,float f_xma,float f_yma)
{
	int
		i_xmi,i_ymi,i_xma,i_yma;
	float	
		f_ech;
	CSize size; 
	CRect rcClient;
  CPoint pt;

	GetClientRect(rcClient);  
	pDC->DPtoLP(rcClient);            
	//1 mm est converti vers 100 pixels graphiques!
  f_ech=100.0;
	i_xmi=(int)(f_ech*f_xmi);
	i_ymi=(int)(f_ech*f_ymi);
	i_xma=(int)(f_ech*f_xma);
	i_yma=(int)(f_ech*f_yma);
	//Dtermination du systme de coordonnes     
	pDC->SetMapMode(MM_ISOTROPIC) ;
	//Dimensions de la fentre 
	size=pDC->SetWindowExt(i_xma-i_xmi,-(i_yma-i_ymi));
  //Dcalage axes
  pt=pDC->SetWindowOrg(i_xmi,i_yma);
	size=pDC->SetViewportExt(rcClient.right,rcClient.bottom);
	return f_ech;
}
//________________________________________
float CBkView::FenetreImp(CDC* pDC,float f_xmi,float f_ymi,float f_xma, float f_yma)
{
	int
		i_xmi,i_ymi,i_xma,i_yma;
	float
		f_ech;
	CRect rcClient;
  CPoint pt;

	GetClientRect(rcClient);  
	pDC->DPtoLP(rcClient);            
	//Dtermination du systme de coordonnes     
	pDC->SetMapMode(MM_TWIPS) ; 
  //SetViewportExt: ignor avec MM_TIPS
  //Echelle pour sortie imprimante en fonction MM_TWIPS
  f_ech=1440.0/25.4;//1 twip = 1/1440e de pouce!
	i_xmi=(int)(f_ech*f_xmi);
	i_ymi=(int)(f_ech*f_ymi);
	i_xma=(int)(f_ech*f_xma);
	i_yma=(int)(f_ech*f_yma);
  //Dcalage axes
  pt=pDC->SetWindowOrg(i_xmi,i_yma);//Position origine
  return f_ech;
}
//________________________________________
BOOL CBkView::AccrocheGraphe(float f_x,float f_y,float *ecart,short *no,short *li,short *co)
{
	short 
		i,j,
		n,k;
	CBkDoc* pDoc=GetDocument(); 
	BOOL OK;
	float 
		x,y,ec,ecmini;

	k=1;
	OK=FALSE;
	ecmini=1e10;
	while (k<32 && !OK)
	{
		//Si le graphe est visualis
		if (pDoc->m_iTypeGr&k)
		{
			pDoc->ColonnesTableau(k,&i,&j);
			n=0;
			while (n<pDoc->m_iNbMax && !OK)
			{
				x=pDoc->m_fT[n][i];
				y=pDoc->m_fT[n][j];
        if (x!=1e10 && y!=1e10)
        {
					ec=pow(pow(x*pDoc->m_fFactx-f_x,2)+pow(y*pDoc->m_fFacty-f_y,2),0.5);
					if (ec<*ecart)
		  		{
						OK=TRUE;      
					}
					if (ec<ecmini) 
					{
						ecmini=ec;
					}
       	}
				n++;
			}
		}
		k=k*2;
	}
	*ecart=ecmini;
	if (OK)
	{
		*li=i;
		*co=j;
		*no=n-1;
	}
	return OK;
}
//________________________________________
void CBkView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	//Menu contextuel -> Activ par bouton droit souris
	//Position souris
	m_point.x=point.x;
	m_point.y=point.y-70;

	CBkDoc* pDoc=GetDocument(); 
	CMenu menu;
	menu.LoadMenu(IDR_POPUP);
	CMenu* pPopup=menu.GetSubMenu(0);
	//Code ou image...
	if (pDoc->m_iTypeGr==0 || pDoc->m_iTypeGr==32) menu.EnableMenuItem(ID__LEGENDE,MF_GRAYED);
	if (pPopup!=NULL) pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,point.x,point.y,this,NULL);
}
//________________________________________
void CBkView::OnMouseMove(UINT nFlags, CPoint point) 
{
	float
		x,y;
	CBkApp* pApp=(CBkApp*)AfxGetApp();
	PIX_FEN(point.x,point.y,&x,&y);
	FEN_GR(x,y,&x,&y);
 	pApp->m_fX=x;
 	pApp->m_fY=y;
 	pApp->m_iX=point.x;
 	pApp->m_iY=point.y;
	CView::OnMouseMove(nFlags, point);
}
//________________________________________
void CBkView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CString s;
	short
		i,j,k,n,no;
	float
		x,y,x1,y1,
		ec,
		f_x,f_y;
		
	CRect 
		rectSave;
	CBkDoc* pDoc=GetDocument(); 
	CBkApp* pApp=(CBkApp*)AfxGetApp();
	CRectTracker tracker;

	PIX_FEN(point.x,point.y,&f_x,&f_y);
	FEN_GR(f_x,f_y,&f_x,&f_y);
	pApp->m_iDx=point.x;
	pApp->m_iDy=point.y;

	if (pDoc->m_iTypeGr!=0 && pDoc->m_iTypeGr!=32)
	//Zoom__________________________________
	if (pDoc->m_OKZoom || pDoc->m_OKExCo)
	{
		pDoc->m_tracker.GetTrueRect(rectSave);
		if (pDoc->m_tracker.HitTest(point)<0)
		{
			if (tracker.TrackRubberBand(this,point,FALSE))
			{
				//MessageBeep(0);//Beep
				tracker.m_rect.NormalizeRect();
				//if (rect.IntersectRect(tracker.m_rect, pDoc->m_tracker.m_rect))
				{
					if (pDoc->m_tracker.m_nStyle & CRectTracker::resizeInside)
					{
						pDoc->m_tracker.m_nStyle &= ~CRectTracker::resizeInside;
						pDoc->m_tracker.m_nStyle |= CRectTracker::resizeOutside;
					}
					else
					{
						pDoc->m_tracker.m_nStyle &= ~CRectTracker::resizeOutside;
						pDoc->m_tracker.m_nStyle |= CRectTracker::resizeInside;
					}
					//pDoc->UpdateAllViews(NULL, (LPARAM)(LPCRECT)rectSave);
				}
			}
			//Mise  jour des coordonnes
			pDoc->m_tracker.m_rect=tracker.m_rect;
		}
		else
		if (pDoc->m_tracker.Track(this,point,FALSE))
		{
			//Quand on dplace la zone digitalise...
			//pDoc->UpdateAllViews(NULL,(LPARAM)(LPCRECT)rectSave);
		}
		//Coordonnes rectangle
		PIX_FEN(pDoc->m_tracker.m_rect.left,pDoc->m_tracker.m_rect.top,&x,&y);
		PIX_FEN(pDoc->m_tracker.m_rect.right,pDoc->m_tracker.m_rect.bottom,&x1,&y1);
		FEN_GR(x,y,&x,&y);
		FEN_GR(x1,y1,&x1,&y1);
		//Affectation dans zone de texte bote de dialogue
		if (pDoc->m_OKZoom) m_pZoomDlg->AffecteRect(x,y1,x1,y);
		if (pDoc->m_OKExCo) m_pExCoDlg->AffecteRect(x,y1,x1,y);
		pDoc->UpdateAllViews(NULL);
	}
	else
	//Rgressions___________________________
	if (pDoc->m_OKReg)
	{
		//N de la rgression
		no=pDoc->m_pReg->m_radioNo;
		if (pDoc->m_pReg->m_iNoBtn[no]>0)
		{
			ec=pDoc->m_pReg->m_fEcart;
			//Recherche si pointage souris peut tre accroch  un graphe...
			m_OK=AccrocheGraphe(f_x,f_y,&ec,&n,&i,&j);
			if (m_OK)
			{
				//On a trouv !!
				x=pDoc->m_fT[n][i];
				y=pDoc->m_fT[n][j];
				s.Format("Point %d trouv:\r\n[%d][%d] - Point n%d\r\nX:%8.3f Y:%8.3f ",pDoc->m_pReg->m_iNoBtn[no],i,j,n,x*pDoc->m_fFactx,y*pDoc->m_fFacty);
				m_pRegDlg->AffecteS(s);
				//Indice de la colonne [0,5]
	  		pDoc->m_pReg->m_iNoColX[no][pDoc->m_pReg->m_iNoBtn[no]-1]=i;
	  		pDoc->m_pReg->m_iNoColY[no][pDoc->m_pReg->m_iNoBtn[no]-1]=j;
	  		//Indice dans le tableau fT [0, m_iNb]
	  		pDoc->m_pReg->m_iNoPt[no][pDoc->m_pReg->m_iNoBtn[no]-1]=n;  
	  		//On a digitalis ce point
	  		pDoc->m_pReg->m_OKPt[no][pDoc->m_pReg->m_iNoBtn[no]-1]=TRUE;
	  		//On mmorise les coordonnes du pt. digitalis
    		if(pDoc->m_pReg->m_iNoBtn[no]==1)
    		{
    			//P1           
    			pDoc->m_pReg->m_fP1[no][0]=x;
    			pDoc->m_pReg->m_fP1[no][1]=y;
    		}
    		if(pDoc->m_pReg->m_iNoBtn[no]==2)
    		{
    			//P2
    			pDoc->m_pReg->m_fP2[no][0]=x;
    			pDoc->m_pReg->m_fP2[no][1]=y;
    		}
	  		if (pDoc->m_pReg->m_OKPt[no][0] && pDoc->m_pReg->m_OKPt[no][1] && (pDoc->m_pReg->m_iNoColX[no][0]==pDoc->m_pReg->m_iNoColX[no][1])&& (pDoc->m_pReg->m_iNoColY[no][0]==pDoc->m_pReg->m_iNoColY[no][1]) && (pDoc->m_pReg->m_iNoPt[no][0] != pDoc->m_pReg->m_iNoPt[no][1]))
	  		{
	  			//Les deux points sont digitaliss, diffrents et appartiennent  la mme courbe
	  			//On valide le bouton calcul
					m_pRegDlg->m_btnCalculer.EnableWindow(TRUE);
				}
			}
			else
			if (pDoc->m_pReg->m_iNoBtn[no]>0)
			{
				//Non trouv, on affiche juste les coordonnes
				s.Format("Point %d non trouv !\r\nX:%8.3f Y:%8.3f\r\nEcart: %1.3f",pDoc->m_pReg->m_iNoBtn[no],f_x,f_y,ec);
				m_pRegDlg->AffecteS(s);
			}
		}			
	}
	else
	{
		//Clic avec le bouton gauche sur le graphe...
		ec=pDoc->m_pReg->m_fEcart;
		//Recherche si pointage souris peut tre accroch  un graphe...
		m_OK=AccrocheGraphe(f_x,f_y,&ec,&n,&i,&j);
		if (m_OK)
		{
			x=pDoc->m_fT[n][i];
 			y=pDoc->m_fT[n][j];
			TAB_GR(x,y,&x,&y);			
 			//Le pointeur est accroch aux mesures
			pApp->m_fDx=x;
 			pApp->m_fDy=y;
			pApp->m_fX=x;
 			pApp->m_fY=y;
			//Mmorisation indices du tableau
			m_iCol=j;m_iLig=i;m_iNo=n;
		}
		else
		{
	 		//Le pointeur est  la position de la souris
 			pApp->m_fDx=f_x;
 			pApp->m_fDy=f_y;
			pApp->m_fX=f_x;
 			pApp->m_fY=f_y;
		}
		//Mise  jour partielle de la vue en dessinant juste ce qui est ncessaire
		MajZone(pApp->m_iXd,pApp->m_iYd,point.x,point.y);
		//pDoc->UpdateAllViews(NULL);

		//Mmorisation coordonnes souris en mm et pixel		
		pApp->m_fXd=pApp->m_fX;
		pApp->m_fYd=pApp->m_fY;
		pApp->m_iXd=point.x;
		pApp->m_iYd=point.y;
	}
	CView::OnLButtonDown(nFlags, point);
}
//________________________________________
void CBkView::OnConnection() 
{
	CPorSeDlg d;
	d.m_pDoc=GetDocument();
	d.DoModal();
}
//________________________________________
void CBkView::OnConnection1() 
{
	CPorSe1Dlg d;
	d.m_pDoc=GetDocument();
	d.DoModal();
}
//________________________________________
void CBkView::OnAcquerir() 
{
	//Acquisition spectre Tektronix
	CAcqDlg d;
	d.m_pDoc=GetDocument();
	d.DoModal();
}
//________________________________________
void CBkView::OnAcqInstek() 
{
	//Acquisition spectre Tektronix
	CAcq1Dlg d;
	d.m_pDoc=GetDocument();
	d.DoModal();
}
//________________________________________
void CBkView::OnUpdateSelGraphe(CCmdUI* pCmdUI) 
{
	CBkDoc* pDoc=GetDocument();                      
	/*
	if (pDoc->m_iTypeAcq==0 || pDoc->m_iTypeAcq==1 || pDoc->m_iTypeAcq==2 || pDoc->m_iTypeAcq==4 || pDoc->m_iTypeAcq==8)
	{
		//Pas de graphe ou un seul graphe, on n'a pas le choix...
		pCmdUI->Enable(FALSE);
	}
	*/
}
//________________________________________
void CBkView::OnSelGraphe() 
{
	CGraDlg d;
	d.m_pDoc=GetDocument();
	d.DoModal();
}
//________________________________________
void CBkView::OnUpdateRegression(CCmdUI* pCmdUI) 
{
	if (GetDocument()->m_iNb==0)	pCmdUI->Enable(FALSE);
	if (GetDocument()->m_iTypeGr==0 || GetDocument()->m_iTypeGr==32)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnRegression() 
{
	CBkDoc* pDoc=GetDocument();                      
	//Rgression linaire
	CWnd* pParent=GetParent();
	CMenu* pMenu=pParent->GetMenu();
	//Ouverture bote de dialogue non modale si elle n'est pas dj ouverte
	if (pDoc->m_OKReg==FALSE)
	{
		m_pRegDlg=new CRegDlg(this);
		//Transmission pDoc vers bote de dialogue	
		//Affectation des valeurs par dfaut   
		m_pRegDlg->Affecte(pDoc);
		//La bote est ouverte, on ne peut pas l'ouvrir une 2me fois
		pDoc->m_OKReg=TRUE;
		//On coche la rubrique du menu
		pMenu->CheckMenuItem(ID_REGRESSION,MF_CHECKED); 
	}	
}
//________________________________________
void CBkView::OnLegende() 
{
	//Lgende
	CInfoDlg dlg;
	dlg.m_pDoc=GetDocument();
	dlg.DoModal();
}
//________________________________________
void CBkView::OnUpdateTxt(CCmdUI* pCmdUI) 
{
	if (GetDocument()->m_iNb==0)	pCmdUI->Enable(FALSE);
	if (GetDocument()->m_iTypeGr==0 || GetDocument()->m_iTypeGr==32)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnTxt() 
{
	//Sauver fichier compatible Excel
	CBkDoc* pDoc=GetDocument();
	static char BASED_CODE szFilter[] = "Fichiers texte (*.txt) | *.txt |Tous les fichiers (*.*) | *.* ||";
	//CFileDialog dlg(FALSE,"",pDoc->m_sNomFicTxt,0,szFilter,NULL) ;
	CFileDialog dlg(FALSE,"","*.txt",0,szFilter,NULL) ;
	if (dlg.DoModal()==IDOK)
	{
		//Affectation nom du fichier
		pDoc->m_sNomFicTxt=dlg.GetPathName();
		//Ouverture du fichier
		CFile fic;
		BOOL ok;
		unsigned int j=IDYES;     
		CFileException p_Error;
		//On regarde si le fichier existe dj
		ok=fic.Open(pDoc->m_sNomFicTxt,CFile::modeRead,&p_Error);
		if (ok)
		{
			j=AfxMessageBox("Ce fichier existe dj. Voulez-vous le remplacer ?",MB_YESNO);
		} 
		if (j==IDYES)
		{
			if (ok) fic.Close();
			EcritureTxt(pDoc->m_sNomFicTxt,1);//Avec intitul des colonnes
		}
	}	
}
//________________________________________
void CBkView::OnUpdateLegende(CCmdUI* pCmdUI) 
{
	//On invalide la rubrique si m_iNb=0
	if (GetDocument()->m_iTypeGr==0 || GetDocument()->m_iTypeGr==32)	pCmdUI->Enable(FALSE);
	if (GetDocument()->m_iNb==0)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnUpdateZoom(CCmdUI* pCmdUI) 
{
	//On invalide la rubrique si m_iNb=0
	if (GetDocument()->m_iTypeGr==0 || GetDocument()->m_iTypeGr==32)	pCmdUI->Enable(FALSE);
	if (GetDocument()->m_iNb==0)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnZoom() 
{
	class CBkDoc* pDoc=GetDocument();                      
	//Rgression linaire
	CWnd* pParent=GetParent();
	CMenu* pMenu=pParent->GetMenu();
	//Ouverture bote de dialogue non modale si elle n'est pas dj ouverte
	if (pDoc->m_OKZoom==FALSE)
	{
		m_pZoomDlg=new CZoomDlg(this);
		//Transmission pDoc vers bote de dialogue	
		//Affectation des valeurs par dfaut   
		m_pZoomDlg->Affecte(pDoc);
		//La bote est ouverte, on ne peut pas l'ouvrir une 2me fois
		pDoc->m_OKZoom=TRUE;
		//On coche la rubrique du menu
		pMenu->CheckMenuItem(ID_ZOOM,MF_CHECKED); 
	}	
}
//________________________________________
BOOL CBkView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	/*
	//Changement de la forme du curseur si on est sur la zone
	CBkDoc* pDoc=GetDocument();
	if (pWnd==this && pDoc->m_tracker.SetCursor(this,nHitTest))
		return TRUE;
	*/
	return CView::OnSetCursor(pWnd,nHitTest,message);
}
//________________________________________
void CBkView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	float x,y;
	short i,j,k;
	class CBkDoc* pDoc=GetDocument();
	class CBkApp* pApp=(CBkApp*)AfxGetApp();
	CString s;
	//Appui touche
	if (m_iLig!=-1 &&	m_iCol!=-1)
	{
		if (nChar==37)
		{
			//Flche gauche
			for (k=0;k<nRepCnt;k++)
			{
				m_iNo--;
				if (m_iNo<0) m_iNo=pDoc->m_iNb;
			}
			x=pDoc->m_fT[m_iNo][m_iLig];
			y=pDoc->m_fT[m_iNo][m_iCol];
			if (x!=1e10 && y!=1e10)
			{
				TAB_GR(x,y,&x,&y);
	 			pApp->m_fDx=x;
				pApp->m_fDy=y;
	 			pApp->m_fX=x;
				pApp->m_fY=y;
				GR_FEN(x,y,&x,&y);
				FEN_PIX(x,y,&i,&j);				
				if (m_OK)	
				{
					MajZone(pApp->m_iXd,pApp->m_iYd,i,j);
					//Mmorisation anciennes coordonnes souris en mm et pixel		
					pApp->m_iXd=i;
					pApp->m_iYd=j;
				}
			}
		}
		if (nChar==39)
		{
			//Flche gauche
			for (k=0;k<nRepCnt;k++)
			{
				m_iNo++;
				if (m_iNo>pDoc->m_iNb) m_iNo=0;
			}
			x=pDoc->m_fT[m_iNo][m_iLig];
			y=pDoc->m_fT[m_iNo][m_iCol];
			if (x!=1e10 && y!=1e10)
			{
				TAB_GR(x,y,&x,&y);
	 			pApp->m_fDx=x;
				pApp->m_fDy=y;
	 			pApp->m_fX=x;
				pApp->m_fY=y;
				GR_FEN(x,y,&x,&y);
				FEN_PIX(x,y,&i,&j);				
				if (m_OK)	
				{
					MajZone(pApp->m_iXd,pApp->m_iYd,i,j);
					//Mmorisation anciennes coordonnes souris en mm et pixel		
					pApp->m_iXd=i;
					pApp->m_iYd=j;
				}
			}
		}
	}
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
//________________________________________
void CBkView::OnGenEan13() 
{
	CGeCoDlg d;
	d.m_pDoc=GetDocument();
	d.DoModal();
}
//________________________________________
void CBkView::OnParametres() 
{
	CParaDlg d;
	d.m_pDoc=GetDocument();
	d.DoModal();
}
//________________________________________
void CBkView::OnUpdateRotationcode(CCmdUI* pCmdUI) 
{
	if (GetDocument()->m_iNb==0)	pCmdUI->Enable(FALSE);
	if (GetDocument()->m_iTypeGr==0 || GetDocument()->m_iTypeGr==32)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnRotationcode() 
{
	CRotDlg d;
	d.m_pDoc=GetDocument();
	d.DoModal();
}
//________________________________________
void CBkView::OnUpdateExtraction(CCmdUI* pCmdUI) 
{
	if (GetDocument()->m_iNb==0)	pCmdUI->Enable(FALSE);
	if (GetDocument()->m_iTypeGr==0 || GetDocument()->m_iTypeGr==32)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnExtraction() 
{
	class CBkDoc* pDoc=GetDocument();                      
	class CWnd* pParent=GetParent();
	class CMenu* pMenu=pParent->GetMenu();
	if (!pDoc->m_OKExCo)
	{
		m_pExCoDlg=new CExCoDlg(this);
		m_pExCoDlg->Affecte(pDoc);
		pDoc->m_OKExCo=TRUE;
		pMenu->CheckMenuItem(ID_EXTRACTION,MF_CHECKED); 
	}	
}
//________________________________________
void CBkView::OnUpdateAnalyse(CCmdUI* pCmdUI) 
{
	if (GetDocument()->m_iTypeGr==0 || GetDocument()->m_iTypeGr==32)	pCmdUI->Enable(FALSE);
	if (GetDocument()->m_iNb==0)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnAnalyse() 
{
	CAnaDlg d;
	d.DoModal();
}
//________________________________________
void CBkView::OnLecteurleuzeConnecter() 
{
	CSerieDlg d;
	d.DoModal();
}
//________________________________________
void CBkView::OnUpdateGenrerFais(CCmdUI* pCmdUI) 
{
}
//________________________________________
void CBkView::OnGenrerFais() 
{
	CLasDlg d;
	d.DoModal();
}
//________________________________________
void CBkView::OnLirecodes() 
{
	CLeLeuDlg d;
	d.DoModal();
}
//________________________________________
void CBkView::OnUpdateAcqEurosmart(CCmdUI* pCmdUI) 
{
	//Eurosmart non disponible sous XP
  if (!(GetVersion() & 0x80000000))
	{
		pCmdUI->Enable(FALSE);
	}	
}
//________________________________________
void CBkView::OnAcqEurosmart() 
{
	CEuroDlg d;
	d.DoModal();
}
//________________________________________
void CBkView::OnLireImage() 
{
	CString s;
	TiffData tif;
	JpegData jpg;
	class CBkDoc* pDoc=GetDocument();
	static char BASED_CODE szFilter[] = "Fichiers images (*.tif)|*.tif|Fichiers images (*.jpg)|*.jpg|Tous les fichiers (*.*)|*.*||";
	CFileDialog dlg(TRUE,"","*.tif;*.jpg",0,szFilter,NULL);
	CFile fic;
	BOOL ok;
	unsigned short j=IDYES;     
	CFileException p_Error;
	short i,rcode=0;
	if (dlg.DoModal()==IDOK)
	{                   
		//Affectation nom du fichier
		s=dlg.GetPathName();
		s.MakeLower();
		if (s.Find(".tif")!=-1)
		{
			tiffinfo(s,&tif);
			freeimage(pDoc->image);
			rcode=allocimage(pDoc->image,tif.width,tif.length,tif.vbitcount);
			//Mmorisation caractristiques image
			pDoc->m_iL=tif.width;
			pDoc->m_iH=tif.length;
			pDoc->m_iNbB=tif.vbitcount;
			loadtif(s,pDoc->image);
		}
		else
		if (s.Find(".jpg")!=-1)
		{
			jpeginfo(s,&jpg);
			freeimage(pDoc->image);
			rcode=allocimage(pDoc->image,jpg.width,jpg.length,jpg.vbitcount);
			//Mmorisation caractristiques image
			pDoc->m_iL=jpg.width;
			pDoc->m_iH=jpg.length;
			pDoc->m_iNbB=jpg.vbitcount;
			rcode=loadjpg(s,pDoc->image);
		}
		else
			rcode=1;
		if (rcode!=0)	AfxMessageBox("Erreur de lecture !");

		pDoc->m_iTypeGr=32;
		pDoc->m_sNomFic=s;
		pDoc->SetTitle(s);	
	}
	pDoc->UpdateAllViews(NULL);
}
//________________________________________
void CBkView::DrawCode(CDC *pDC)
{
	CBkDoc* pDoc=GetDocument();
	CBkApp* pApp=(CBkApp*)AfxGetApp();
	float 
		x,y,
		xmi,ymi,xma,yma,
		ech;
	//Limites_______________________________
	xmi=pDoc->m_fXmi=-30;
	ymi=pDoc->m_fYmi=-95;
	xma=pDoc->m_fXma=240;
	yma=pDoc->m_fYma=95;
	//Dcalage d'origine, chelles et facteurs d'chelle
	pDoc->m_fXori=0;
	pDoc->m_fYori=0;
	pDoc->m_fEchx=1;
	pDoc->m_fEchy=1;
	pDoc->m_fFactx=1;
	pDoc->m_fFacty=1; 
	if (pDC->IsPrinting())
	{
		ech=FenetreImp(pDC,xmi,ymi,xma,yma);
		//Pas de marque de pointage
		pApp->m_fDx=1e10;
		pApp->m_fDy=1e10;
	}
	else
	{
		ech=Fenetre(pDC,xmi,ymi,xma,yma);
	}
  CPen 
		plumeA,       
  	*m_pOldPen;
	CFont 
		fntA,fntB,  
		*m_pOldFont;
	COLORREF clrOld;	
	fntA.CreateFont((int)(ech*4.5*0.8),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	fntB.CreateFont((int)(ech*4.5*2.0),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=pDC->SelectObject(&fntA);	  

	plumeA.CreatePen(PS_SOLID,(int)(0.20*ech),RGB(0,0,0));
	m_pOldPen=pDC->SelectObject(&plumeA);        
	pDC->Rectangle(xmi*ech,ymi*ech,xma*ech,yma*ech);
	pDC->Rectangle((xmi+5)*ech,(ymi+5)*ech,(xma-5)*ech,(yma-5)*ech);
	
	pDC->SetTextAlign(TA_BASELINE);							
	clrOld=pDC->SetTextColor(RGB(0,0,255));
	pDC->TextOut((xmi+5.0)*ech,(ymi+1.50)*ech,"B.K. - Lyce J. Mermoz - 68300 ST.-LOUIS");
	//Date et heure
	CTime t;
	CString s; 
	setlocale(LC_TIME,"French");
	t=CTime::GetCurrentTime();   
	s=t.Format("%A, %d %B %Y - %H:%M:%S");
	pDC->TextOut((xmi+5.0)*ech,(yma-4.20)*ech,s);
	CCode *pCode;
	pCode=new CCode(pDC);
	float 
		T,E,H,
		L;
	short i;

	x=xmi+10;
	y=yma-25;
	for (i=0;i<8;i++)
	{
		E=pDoc->m_fEpaisE[i];
		T=pDoc->m_fEpaisT[i];
		H=T*40;if (H>25) H=25;
		pCode->Taille(T,E,H);//Larg. du trait fin, larg. espace simple, hauteur, ...
		pCode->Couleur(pDoc->m_lCb[i],pDoc->m_lCf[i]);
		//Longueur en mm du code  afficher
		L=46*T+48*E;		
		if (x+L>xma-10)
		{
			//On passe  la ligne suivante....
			x=xmi+10;
			y=y-40;
		}
		if (y>ymi+H+10) pCode->TraceCode(x,y,pDoc->m_sCode);
		x=x+L+10;
	}
	delete pCode;
	//Ecriture code centr
	pDC->SelectObject(&fntB);
	pDC->SetTextAlign(TA_CENTER);
	pDC->SetTextColor(RGB(0,0,255));
	s.Format("CODE EAN13: %s",pDoc->m_sCode);
	pDC->TextOut(ech*(xmi+xma)/2,ech*(ymi+20),s);

	pDC->SelectObject(m_pOldPen);        
	plumeA.DeleteObject();        
	pDC->SelectObject(m_pOldFont);        
	fntA.DeleteObject();
	fntB.DeleteObject();
	pDC->SetTextColor(clrOld);
}
