// BkView.h : interface of the CBkView class
//
/////////////////////////////////////////////////////////////////////////////
class CBkView : public CView
{
protected: // create from serialization only
	CBkView();
	DECLARE_DYNCREATE(CBkView)

// Attributes
public:
	CBkDoc* GetDocument();

// Operations
public:
	class CRegDlg* m_pRegDlg;
	class CCurseurDlg* m_pCurDlg;
	class CZoomDlg* m_pZoomDlg;
	class CExCoDlg* m_pExCoDlg;
	CPoint m_point;
	BOOL m_OK;
	short
		m_iLig,m_iCol,m_iNo;

protected:
	float Fenetre(CDC* pDC,float f_xmi,float f_ymi,float f_xma,float f_yma);
	float FenetreImp(CDC* pDC,float f_xmi,float f_ymi,float f_xma, float f_yma);

	void DrawGraphe(CDC *pDC);
	void DrawCode(CDC *pDC);
	void DrawImage(CDC *pDC);

	void EcritureTxt(CString sFic, char Type);
	BOOL AccrocheGraphe(float f_x,float f_y,float *ecart,short *no,short *li,short *co);
	//Contextuels
	void InitSouris();
	void OnDefinirLegende();
	//Changement de coordonnes sens 1
	void PIX_FEN(short xp,short yp,float *xmm,float *ymm);
	void FEN_GR(float xmm,float ymm,float *x,float *y);
	void GR_TAB(float x,float y,float *xt,float *yt);
	//Changement de coordonnes sens 2
	void TAB_GR(float xt,float yt,float *x,float *y);
	void GR_FEN(float x,float y,float *xmm,float *ymm);
	void FEN_PIX(float xmm,float ymm,short *xp,short *yp);
	void MajZone(short x1,short y1,short x2,short y2);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBkView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBkView)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnConnection();
	afx_msg void OnAcquerir();
	afx_msg void OnUpdateSelGraphe(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRegression(CCmdUI* pCmdUI);
	afx_msg void OnLegende();
	afx_msg void OnUpdateTxt(CCmdUI* pCmdUI);
	afx_msg void OnTxt();
	afx_msg void OnRegression();
	afx_msg void OnUpdateZoom(CCmdUI* pCmdUI);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSelGraphe();
	afx_msg void OnZoom();
	afx_msg void OnUpdateExtraction(CCmdUI* pCmdUI);
	afx_msg void OnExtraction();
	afx_msg void OnGenEan13();
	afx_msg void OnParametres();
	afx_msg void OnUpdateRotationcode(CCmdUI* pCmdUI);
	afx_msg void OnRotationcode();
	afx_msg void OnUpdateAnalyse(CCmdUI* pCmdUI);
	afx_msg void OnAnalyse();
	afx_msg void OnLecteurleuzeConnecter();
	afx_msg void OnLirecodes();
	afx_msg void OnAcqEurosmart();
	afx_msg void OnLireImage();
	afx_msg void OnUpdateLegende(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAcqEurosmart(CCmdUI* pCmdUI);
	afx_msg void OnConnection1();
	afx_msg void OnAcqInstek();
	afx_msg void OnUpdateGenrerFais(CCmdUI* pCmdUI);
	afx_msg void OnGenrerFais();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BkView.cpp
inline CBkDoc* CBkView::GetDocument()
   { return (CBkDoc*)m_pDocument; }
#endif
/////////////////////////////////////////////////////////////////////////////
