//Classe CCode
//
#include "stdafx.h"
#include "bk.h"
#include "Code.h"
#include "BkDoc.h"
#include "Dessin.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//Constructeur de base ___________________
CCode::CCode(class CDC *pDC)
{
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	m_pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	m_iTypeConstructeur=0;
	m_pDes=new CDessin(pDC);

	m_fTrait=0.5;                       
	m_fBlanc=0.5;
	m_fHaut=20;
	
	m_fHaut=m_fHaut/2;							//Demi-hauteur du code
	m_fLarg=2*m_fTrait+5*m_fBlanc;	//Largeur d'un chiffre du code en mm, bas sur le chiffre 8C

	m_pDC=pDC;
	Affectation();          
	//Couleurs
	m_lCb=RGB(0,0,0);
	m_lCf=RGB(255,255,255);
	m_iNbF=0;
	for (short i=0;i<60;i++)
	{
		m_sBinaire[i]="";
		m_fMult[i]=1e10;
	}

}
//Constructeur surcharg _________________
CCode::CCode(void)
{
	m_iTypeConstructeur=1;
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	m_pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	Affectation();          
}
//________________________________________
CCode::~CCode()
{
	if (m_iTypeConstructeur==0) delete m_pDes;
}
//________________________________________
void CCode::Affectation(void)
{
	//Affectation des codes dans le tableau C
	C[0][0]=13;	C[0][1]=39;	C[0][2]=114;	//Chiffre 0
	C[1][0]=25;	C[1][1]=51;	C[1][2]=102;	//Chiffre 1
	C[2][0]=19;	C[2][1]=27;	C[2][2]=108;	//Chiffre 2
	C[3][0]=61;	C[3][1]=33;	C[3][2]=66;		//Chiffre 3
	C[4][0]=35;	C[4][1]=29;	C[4][2]=92;		//Chiffre 4
	C[5][0]=49;	C[5][1]=57;	C[5][2]=78;		//Chiffre 5
	C[6][0]=47;	C[6][1]=5;	C[6][2]=80;		//Chiffre 6
	C[7][0]=59;	C[7][1]=17;	C[7][2]=68;		//Chiffre 7
	C[8][0]=55;	C[8][1]=9;	C[8][2]=72;		//Chiffre 8
	C[9][0]=11;	C[9][1]=23;	C[9][2]=116;	//Chiffre 9
	//Types pour codes de 1  6 en fonction du dernier chiffre
	m_sType[0]="AAAAAA";
	m_sType[1]="AABABB";
	m_sType[2]="AABBAB";
	m_sType[3]="AABBBA";
	m_sType[4]="ABAABB";
	m_sType[5]="ABBAAB";
	m_sType[6]="ABBBAA";
	m_sType[7]="ABABAB";
	m_sType[8]="ABABBA";
	m_sType[9]="ABBABA";
}
//________________________________________
//Trac du code complet
void CCode::TraceCode(float x,float y,CString Code)
{
	CFont 
		fntA,  
		*m_pOldFont;
	COLORREF clrOld;	
	CString s;
	int i,d,k;
	char c;
	float X;

	fntA.CreateFont((int)(m_pDes->m_ech*m_fHaut/3.5),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntA);	  
	clrOld=m_pDC->SetTextColor(RGB(0,0,255));
	
	CodeRef('G',x,y);//Barre rfrence gauche
	CodeRef('M',x,y);//Barre rfrence milieu
	CodeRef('D',x,y);//Barre rfrence droite
	if (Code.GetLength()!=13)
	{
		//Erreur !
	}
	else
	{
		//Couleurs m_lCb,m_lCf
		unsigned char bR,bV,bB,fR,fV,fB;
		bR=m_lCb&255;
		bV=(m_lCb>>8)&255;
		bB=(m_lCb>>16)&255;
		fR=m_lCf&255;
		fV=(m_lCf>>8)&255;
		fB=(m_lCf>>16)&255;

		m_pDC->SetTextAlign(TA_LEFT);							
		s.Format("T:%1.2f, E:%1.2f, (%d,%d,%d) (%d,%d,%d)",m_fTrait,m_fBlanc,bR,bV,bB,fR,fV,fB);
		m_pDes->texte(x,y+1.4*m_fHaut,s);
		//Extraction code pays
		s.Format("%c",Code[0]);
		k=sscanf(s,"%d",&i);
		if (k==1)
			s.Format("%d",i);
		else
			s="?";

		m_pDC->SetTextAlign(TA_RIGHT);							
		m_pDes->texte(x-1,y-1.2*m_fHaut,s);

		//Premier chiffre pour type code
		s.Format("%c",Code[0]);
		sscanf(s,"%d",&d);

		m_pDC->SetTextAlign(TA_CENTER);
		X=x+2*m_fTrait+m_fBlanc+m_fLarg/2;
		//Extraction des autres codes
		for (k=0;k<6;k++)
		{
			s.Format("%c",Code[k+1]);
			sscanf(s,"%d",&i);
			s.Format("%d",i);
			m_pDes->texte(X,y-1.2*m_fHaut,s);
			c=m_sType[d][k];

			s.Format("%c",c);
			m_pDes->texte(X,y-1.5*m_fHaut,s);

			CodeChiffre(i,k+1,c,x,y);
			X=X+m_fLarg;
		}
		X=X+2*m_fTrait+3*m_fBlanc;
		for (k=6;k<12;k++)
		{
			s.Format("%c",Code[k+1]);
			sscanf(s,"%d",&i);
			s.Format("%d",i);
			m_pDes->texte(X,y-1.2*m_fHaut,s);

			s.Format("C");
			m_pDes->texte(X,y-1.5*m_fHaut,s);

			CodeChiffre(i,k+1,'C',x,y);
			X=X+m_fLarg;
		}
	}
	m_pDC->SelectObject(m_pOldFont);        
	fntA.DeleteObject();
	m_pDC->SetTextColor(clrOld);
}
//________________________________________
void CCode::CodeRef(char Pos,float x,float y)
{
	float X,X1;
	CBrush 
		*m_pOldBrush,
		brosseA,
		brosseB;

	brosseA.CreateSolidBrush(m_lCb);
	brosseB.CreateSolidBrush(m_lCf);
	m_pOldBrush=m_pDC->SelectObject(&brosseA);
	switch (Pos)
	{
		case 'G'://Gauche
			X=x;
			m_pDes->cercle(X,y+m_fHaut,m_fTrait/3);
			m_pDC->SelectObject(&brosseA);
			m_pDes->barre(X,y-1.4*m_fHaut,X+1*m_fTrait,y+m_fHaut);
			X=X+m_fTrait;
			m_pDC->SelectObject(&brosseB);
			m_pDes->barre(X,y-1.4*m_fHaut,X+1*m_fBlanc,y+m_fHaut);
			X=X+m_fBlanc;
			m_pDC->SelectObject(&brosseA);
			m_pDes->barre(X,y-1.4*m_fHaut,X+1*m_fTrait,y+m_fHaut);
			X=X+m_fTrait;
			//m_pDes->cadre(x,y-1*m_fHaut,X,y+m_fHaut);
			m_pDes->cercle(X,y+m_fHaut,m_fTrait/3);
		break;
		case 'M'://Milieu
			X=x+2*m_fTrait+1*m_fBlanc+6*m_fLarg;
			X1=X+2*m_fTrait+3*m_fBlanc;
			//m_pDes->cadre(X,y-1*m_fHaut,X1,y+m_fHaut);
			m_pDes->cercle(X1,y+m_fHaut,m_fTrait/3);

			X1=X+m_fBlanc;
			m_pDC->SelectObject(&brosseB);
			m_pDes->barre(X,y-1.4*m_fHaut,X1,y+m_fHaut);
			X=X1;
			X1=X+m_fTrait;
			m_pDC->SelectObject(&brosseA);
			m_pDes->barre(X,y-1.4*m_fHaut,X1,y+m_fHaut);
			X=X1;
			X1=X+m_fBlanc;
			m_pDC->SelectObject(&brosseB);
			m_pDes->barre(X,y-1.4*m_fHaut,X1,y+m_fHaut);
			X=X1;
			X1=X+m_fTrait;
			m_pDC->SelectObject(&brosseA);
			m_pDes->barre(X,y-1.4*m_fHaut,X1,y+m_fHaut);
			X=X1;
			X1=X+m_fBlanc;
			m_pDC->SelectObject(&brosseB);
			m_pDes->barre(X,y-1.4*m_fHaut,X1,y+m_fHaut);
		break;
		case 'D'://Droite
			X=x+4*m_fTrait+4*m_fBlanc+12*m_fLarg;
			X1=X+2*m_fTrait+1*m_fBlanc;
			//m_pDes->cadre(X,y-1*m_fHaut,X1,y+m_fHaut);
			m_pDes->cercle(X1,y+m_fHaut,m_fTrait/3);
			X1=X+m_fTrait;
			m_pDC->SelectObject(&brosseA);
			m_pDes->barre(X,y-1.4*m_fHaut,X1,y+m_fHaut);
			X=X1;
			X1=X+m_fBlanc;
			m_pDC->SelectObject(&brosseB);
			m_pDes->barre(X,y-1.4*m_fHaut,X+1*m_fBlanc,y+m_fHaut);
			X=X1;
			X1=X+m_fTrait;
			m_pDC->SelectObject(&brosseA);
			m_pDes->barre(X,y-1.4*m_fHaut,X1,y+m_fHaut);
		break;
	}
	m_pDC->SelectObject(m_pOldBrush);
	brosseA.DeleteObject();
	brosseB.DeleteObject();
}
//Trac du code du Chiffre [0,9] _________
void CCode::CodeChiffre(short Chiffre,short No,char Digit,float x,float y)
{
	short i,j,k;
	float X;
	CBrush 
		*m_pOldBrush,
		brosseA,
		brosseB;

	brosseA.CreateSolidBrush(m_lCb);
	brosseB.CreateSolidBrush(m_lCf);

	m_pOldBrush=m_pDC->SelectObject(&brosseB);

	if (Digit=='A')	k=0; 
		else 
	if (Digit=='B')	k=1;
		else k=2;//'C' 

	if (Digit=='C')
	{
		//On dcale  cause du code de dbut et de milieu
		X=x+(No-1)*m_fLarg+4*m_fTrait+4*m_fBlanc;
		m_pDC->SelectObject(&brosseB);
		m_pDes->barre(X,y-m_fHaut,X+m_fLarg,y+m_fHaut);
		//m_pDes->cadre(X,y-m_fHaut,X+m_fLarg,y+m_fHaut);
		m_pDes->cercle(X+m_fLarg,y+m_fHaut,m_fTrait/3);
		i=64;
		while (i>=1)
		{
			if (C[Chiffre][k]&i)
			{
				m_pDC->SelectObject(&brosseA);
				m_pDes->barre(X,y-m_fHaut,X+m_fTrait,y+m_fHaut);
				X=X+m_fTrait;
			}
			else
			{
				X=X+m_fBlanc;
			}
			i=i/2;
		}
	}
	else
	{
		//On dcale  cause du code de dbut
		X=x+No*m_fLarg+2*m_fTrait+1*m_fBlanc;
		m_pDC->SelectObject(&brosseB);
		m_pDes->barre(X-m_fLarg,y-m_fHaut,X,y+m_fHaut);
		//m_pDes->cadre(X-m_fLarg,y-m_fHaut,X,y+m_fHaut);
		m_pDes->cercle(X,y+m_fHaut,m_fTrait/3);
		//On crit le code de droite vers la gauche
		i=1;
		while (i<=64)
		{
			if (C[Chiffre][k]&i)
			{
				m_pDC->SelectObject(&brosseA);
				m_pDes->barre(X-m_fTrait,y-m_fHaut,X,y+m_fHaut);
				X=X-m_fTrait;
			}
			else
			{
				X=X-m_fBlanc;
			}
			i=i*2;

		}
	}
	m_pDC->SelectObject(m_pOldBrush);
	brosseA.DeleteObject();
	brosseB.DeleteObject();
}
//________________________________________
void CCode::Taille(float T,float B,float H)
{
	if (T>B)
	{
		m_fTrait=B;                       
		m_fBlanc=T;
	}
	else
	{
		m_fTrait=T;                       
		m_fBlanc=B;
	}
	m_fHaut=H/2;										//Demi-hauteur du code
	m_fLarg=2*m_fTrait+5*m_fBlanc;	//Largeur d'un chiffre du code en mm, bas sur le chiffre 8C
}
//________________________________________
void CCode::Couleur(unsigned long CoulB,unsigned long CoulF)
{
	m_lCb=CoulB;
	m_lCf=CoulF;
}
//________________________________________
void CCode::TB(float *m_fF,short NbF,float *T,float *B)
{
	float 
		b1,b2,
		r1,r2,r3,r4;

	//Nb. de fronts
	m_iNbF=NbF;

	if (NbF<32)
	{
		//Les barres du milieu ne sont pas prsentes
		r1=m_fF[1]-m_fF[0];
		r2=m_fF[3]-m_fF[2];
		*T=(r1+r2)/2;
		//Extraction paisseur blanc simple
		*B=m_fF[2]-m_fF[1];
		AfxMessageBox("Barres du milieu absentes.\nLargeurs rfrences sur barres de gauche...");
	}
	else
	{
		//Extraction paisseur barre simple sur moyenne milieu et gauche
		r1=m_fF[1]-m_fF[0];
		r2=m_fF[3]-m_fF[2];
		r3=m_fF[29]-m_fF[28];
		r4=m_fF[31]-m_fF[30];
		//Prendre uniquement au milieu  cause barres de largeur progressive...
		//*T=(r1+r2+r3+r4)/4;
		*T=(r3+r4)/2;

		//Extraction paisseur blanc simple
		b2=m_fF[30]-m_fF[29];
		b1=m_fF[2]-m_fF[1];
		//*B=(b2+b1)/2;
		*B=b2;
	}
	m_fT=*T;
	m_fB=*B;
}
//________________________________________
short CCode::ExtractionGauche(float *m_fF, short Nb,float T,float B)
{
	short
		i,j,n,
		er=0;

	CString 
		CodePays="XXXXXX",
		s;
	char 
		c,Type;

	//Extraction code gauche
	j=1;
	i=3;//On commence au 3me front
	do
	{
		if (i+4<=Nb)
		{
			n=ChiffreG(m_fF,&i,&Type,B,T);
			if (n>=0 && n<=9)
			{
				s.Format("%d",n);
				c=s[0];
				m_pDoc->m_sCode.SetAt(j,c);	
				if (Type=='A' || Type=='B') CodePays.SetAt(j-1,Type);
				j++;
			}
			else
			{
				if ((er&2)!=2) er=er+2;//er&2: Erreur d'extraction du chiffre gauche j
			}
			
		}
		else
		{
			if ((er&1)!=1) er=er+1;//er&1: Nb. de fronts insuffisants
		}
	}
	while (i<27 && i+4<=Nb);
	//Affectation premier chiffre code en fonction code pays
	for (n=0;n<10;n++)
	{
		if (CodePays==m_sType[n])
		{
			s.Format("%d",n);
			m_pDoc->m_sCode.SetAt(0,s[0]);
		}
	}	
	if (n==9 && CodePays!=m_sType[i]) er=er+4;//Erreur sur code pays

	//Vrification parit
	j=CodeControle(m_pDoc->m_sCode);
	//Extraction du dernier chiffre du code
	s.Format("%c",m_pDoc->m_sCode[12]);sscanf(s,"%u",&n);
	/*
	if (n!=j && (er&8)!=8)
	{
		er=er+8;//Erreur de parit
	}
	*/
	/*
	s="Bilan code gauche:\n";
	CString s1;
	for (i=0;i<30;i++)
	{
		if (m_fMult[i]!=1e10 && m_sBinaire[i].GetLength()!=0)
		{
			s1.Format("%5s\tMult:%1.2f\n",m_sBinaire[i],m_fMult[i]);
			s=s+s1;
		}
	}
	AfxMessageBox(s);
	*/
	return er;
}
//________________________________________
short CCode::ExtractionDroite(float *m_fF, short Nb,float T,float B)
{
	short
		i,j,n,
		er=0;
	CString s;
	char c;

	i=32;
	j=7;
	do
	{
		if (i+4<Nb)
		{
			n=ChiffreD(m_fF,&i,B,T);//Forcment du type 'C';
			if (n>=0 && n<=9)
			{
				s.Format("%d",n);
				c=s[0];
				m_pDoc->m_sCode.SetAt(j,c);		
			}
			else
			{
				if ((er&16)!=16) er=er+16;//er&16: Erreur d'extraction du chiffre droit j
			}
		}
		else
		{
			if ((er&1)!=1) er=er+1;//er&1: Nb. de fronts insuffisants
		}
		if (j<12) j++;
	}
	while (i<=52 && i+4<Nb);
	//Vrification parit
	j=CodeControle(m_pDoc->m_sCode);
	//Extraction du dernier chiffre du code
	s.Format("%c",m_pDoc->m_sCode[12]);sscanf(s,"%u",&n);
	if (n!=j && (er&8)!=8)
	{
		er=er+8;//Erreur de parit
	}
	/*
	s="Bilan code droit:\n";
	for (i=32;i<60;i++)
	{
		if (m_fMult[i]!=1e10 && m_sBinaire[i].GetLength()!=0)
		{
			s1.Format("%5s\tMult:%1.2f\n",m_sBinaire[i],m_fMult[i]);
			s=s+s1;
		}
	}
	AfxMessageBox(s);
	*/
	return er;
}
//________________________________________
short CCode::Extraction(float *m_fF, short Nb,float T,float B)
{
	char
		Type;
	short
		i,n,
		er1=0,er2=0;
	CString s;	 

	if (Nb>48)
	{
		//Extraction droite et gauche
		m_pDoc->m_sCode="0000000000000";
		er1=ExtractionGauche(m_fF,Nb,T,B);
		er2=ExtractionDroite(m_fF,Nb,T,B);
	}
	else
	{
		float mult;
		//Extraction partielle droite ou gauche
		i=3;	
		n=MultipleB(m_fF,i,B,&mult);
		if (n==1)
		{
			s.Format("Extraction code droit ...\nXXXXXXX%s",m_pDoc->m_sCode.Mid(7,6));
			AfxMessageBox(s);
			er2=ExtractionDroite(m_fF,Nb,T,B);
		}
		else
		{
			er1=ExtractionGauche(m_fF,Nb,T,B);
			s.Format("Extraction code gauche ...\n%sXXXXXX",m_pDoc->m_sCode.Left(7));
			AfxMessageBox(s);
		}
	}
	return er1+er2;
}
//________________________________________
short CCode::ChiffreG(float *m_fF,short *No,char *Type,float B,float T)
{
	CString Chiffre;
	short i,n;
	float mult;

	Chiffre="";
	//Deuxime trait
	n=MultipleT(m_fF,*No+3,T,&mult);
	for (i=0;i<n;i++)
	{
		Chiffre=Chiffre+"1";
		m_sBinaire[*No+3]=m_sBinaire[*No+3]+"1";
	}
	//Affectation paramtres
	m_fMult[*No+3]=mult;

	//Deuxime blanc
	n=MultipleB(m_fF,*No+2,B,&mult);
	for (i=0;i<n;i++) 
	{
		if (Chiffre.GetLength()<5) 
		{
			Chiffre="0"+Chiffre;
			m_sBinaire[*No+2]=m_sBinaire[*No+2]+"0";
		}
	}
	m_fMult[*No+2]=mult;

	//Premier trait
	n=MultipleT(m_fF,*No+1,T,&mult);
	for (i=0;i<n;i++) 
	{
		//Il faut laisser au moins un blanc
		if (Chiffre.GetLength()<6)
		{
			Chiffre="1"+Chiffre;
			m_sBinaire[*No+1]=m_sBinaire[*No+1]+"1";
		}
	}
	m_fMult[*No+1]=mult;
	
	//On complte  7 bits
	for (i=Chiffre.GetLength();i<7;i++) 
	{
		Chiffre="0"+Chiffre;
		m_sBinaire[*No]=m_sBinaire[*No]+"0";
	}
	m_fMult[*No]=1;

	//On avance de 4 fronts
	*No=*No+4;
	//AfxMessageBox(Chiffre);
	
	n=0;
	if (Chiffre.GetLength()>=1)
	{
		if (Chiffre[0]=='1') n=n+64;
	}
	if (Chiffre.GetLength()>=2)
	{
		if (Chiffre[1]=='1') n=n+32;
	}
	if (Chiffre.GetLength()>=3)
	{
		if (Chiffre[2]=='1') n=n+16;
	}
	if (Chiffre.GetLength()>=4)
	{
		if (Chiffre[3]=='1') n=n+8;
	}
	if (Chiffre.GetLength()>=5)
	{
		if (Chiffre[4]=='1') n=n+4;
	}
	if (Chiffre.GetLength()>=6)
	{
		if (Chiffre[5]=='1') n=n+2;
	}
	if (Chiffre.GetLength()>=7)
	{
		if (Chiffre[6]=='1') n=n+1;
	}
	short Code;
	BOOL ok;
	ok=ChiffreCode(n,&Code,Type);
	if (!ok) Code=-1;
	return Code;
}
//________________________________________
short CCode::ChiffreD(float *m_fF,short *No,float B,float T)
{
	CString s,Chiffre;
	short i,n;
	float mult;

	Chiffre="";
	//Premier trait
	n=MultipleT(m_fF,*No,T,&mult);
	for (i=0;i<n;i++) 
	{
		if (Chiffre.GetLength()<4) 
		{
			Chiffre=Chiffre+"1";
			m_sBinaire[*No]=m_sBinaire[*No]+"1";
		}
	}
	m_fMult[*No]=mult;

	//Premier blanc
	n=MultipleB(m_fF,*No+1,B,&mult);
	if (n==4)
	{
		//Le premier blanc ne peut tre quadruple que si la premire barre est d'paisseur 1
		if (Chiffre.GetLength()!=1) n=3;
	}

	for (i=0;i<n;i++) 
	{
		if (Chiffre.GetLength()<5)
		{
			Chiffre=Chiffre+"0";
			m_sBinaire[*No+1]=m_sBinaire[*No+1]+"0";
		}
		else
		{
			//s.Format("Erreur code droit, blanc n1, front n%d",*No+1);
			//AfxMessageBox(s);
		}

	}
	m_fMult[*No+1]=mult;

	//Deuxime trait
	n=MultipleT(m_fF,*No+2,T,&mult);
	for (i=0;i<n;i++) 
	{
		//Il faut laisser au moins un blanc
		if (Chiffre.GetLength()<6)
		{
			Chiffre=Chiffre+"1";
			m_sBinaire[*No+2]=m_sBinaire[*No+2]+"1";
		}
		else
		{
			//s.Format("Erreur code droit, trait n2, front n%d",*No+2);
			//AfxMessageBox(s);
		}
	}
	m_fMult[*No+2]=mult;
	//Deuxime blanc
	//On complte  7 bits
	for (i=Chiffre.GetLength();i<7;i++) 
	{
		Chiffre=Chiffre+"0";
		m_sBinaire[*No+3]=m_sBinaire[*No+3]+"0";
	}
	m_fMult[*No+3]=1;

	n=0;
	if (Chiffre.GetLength()>=1)
	{
		if (Chiffre[0]=='1') n=n+64;
	}
	if (Chiffre.GetLength()>=2)
	{
		if (Chiffre[1]=='1') n=n+32;
	}
	if (Chiffre.GetLength()>=3)
	{
		if (Chiffre[2]=='1') n=n+16;
	}
	if (Chiffre.GetLength()>=4)
	{
		if (Chiffre[3]=='1') n=n+8;
	}
	if (Chiffre.GetLength()>=5)
	{
		if (Chiffre[4]=='1') n=n+4;
	}
	if (Chiffre.GetLength()>=6)
	{
		if (Chiffre[5]=='1') n=n+2;
	}
	if (Chiffre.GetLength()>=7)
	{
		if (Chiffre[6]=='1') n=n+1;
	}

	//AfxMessageBox(Chiffre);

	short Code;
	BOOL ok;
	char c='C';
	ok=ChiffreCode(n,&Code,&c);
	if (c!='C') ok=FALSE;
	*No=*No+4;
	if (ok)
		return Code;
	else
		return -1;
}
//________________________________________
BOOL CCode::ChiffreCode(short n,short *pChiffre, char *pType)
{
	//Extraction de 0A  partir de 13...
	short i;
	BOOL ok=FALSE;
	*pChiffre=0;
	*pType='A';
	for (i=0;i<10;i++)
	{
		if (n==C[i][0])
		{
			*pType='A';
			*pChiffre=i;
			ok=TRUE;
		}
	}
	for (i=0;i<10;i++)
	{
		if (n==C[i][1])
		{
			*pType='B';
			*pChiffre=i;
			ok=TRUE;
		}
	}
	for (i=0;i<10;i++)
	{
		if (n==C[i][2])
		{
			*pType='C';
			*pChiffre=i;
			ok=TRUE;
		}
	}
	return ok;
}
//________________________________________
//Recherche de la largeur du trait ou du blanc
//1: Trait simple ou blanc simple
//2: Trait double ou blanc doule...
//Multiple d'un trait_____________________
short CCode::MultipleT(float *m_fF,short No,float Ref,float *Mult)
{
	float r,X,X1;
	short i;

	X=m_fF[No];
	//Il faut une largeur d'au moins la ref, sinon parasites...
	X1=m_fF[(No)+1];
	if (Ref!=0) 
		r=(X1-X)/Ref;
	else 
		r=0;
	
	//Les traits sont sur les fronts pairs
	if (No%2!=0)
	{
		i=1;
	}
	else
	{
		//Recherche de l'entier le plus proche
		if (r<1.5)
			i=1;
		else
		if (r<2.5)
			i=2;
		else
		if (r<3.65)
			i=3;
		else
			i=4;

		if (No<30)
		{
			//A gauche
		}
		else
		{
			//A droite, il n'y a au plus 3 traits
			if (i>3) i=3;
		}
	}
	if (i<1) i=1;
	if (i>4) i=4;
			
	*Mult=r;	
	return i;
}
//Multiple d'un blanc_____________________
short CCode::MultipleB(float *m_fF,short No,float Ref,float *Mult)
{
	float r,X,X1;
	short i;

	X=m_fF[No];
	//Il faut une largeur d'au moins la ref, sinon parasites...
	X1=m_fF[(No)+1];
	if (Ref!=0) 
		r=(X1-X)/Ref;
	else 
		r=0;
	
	//Les blancs sont sur les fronts impairs
	if (No%2==0)
	{
		i=1;
	}
	else
	{
		//Recherche de l'entier le plus proche
		if (r<1.5)
			i=1;
		else
		if (r<2.5)
			i=2;
		else
		if (r<3.3)
			i=3;
		else
			i=4;

		if (No<30)
		{
			//A gauche
		}
		else
		{
			//A droite
		}
	}
	if (i<1) i=1;
	if (i>4) i=4;
			
	//CString s;
	//s.Format ("No:%d\nRef: %e\nX1-X: %e\nr: %4.2f\ni:%d",No,Ref,X1-X,r,i);
	//AfxMessageBox(s);
	*Mult=r;	
	return i;
}
//________________________________________
short CCode::CodeControle(CString Code) 
{
	int n,p,i,k;
	CString s;
	p=0;
	i=0;
	if (Code.GetLength()>=1)
	{
		s.Format("%c",Code[0]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (Code.GetLength()>=2)
	{
		s.Format("%c",Code[1]);sscanf(s,"%u",&n);
		p=p+n;
	}
	if (Code.GetLength()>=3)
	{
		s.Format("%c",Code[2]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (Code.GetLength()>=4)
	{
		s.Format("%c",Code[3]);sscanf(s,"%u",&n);
		p=p+n;
	}
	if (Code.GetLength()>=5)
	{
		s.Format("%c",Code[4]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (Code.GetLength()>=6)
	{
		s.Format("%c",Code[5]);sscanf(s,"%u",&n);
		p=p+n;
	}
	if (Code.GetLength()>=7)
	{
		s.Format("%c",Code[6]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (Code.GetLength()>=8)
	{
		s.Format("%c",Code[7]);sscanf(s,"%u",&n);
		p=p+n;
	}
	if (Code.GetLength()>=9)
	{
		s.Format("%c",Code[8]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (Code.GetLength()>=10)
	{
		s.Format("%c",Code[9]);sscanf(s,"%u",&n);
		p=p+n;
	}
	if (Code.GetLength()>=11)
	{
		s.Format("%c",Code[10]);sscanf(s,"%u",&n);
		i=i+n;
	}
	if (Code.GetLength()>=12)
	{
		s.Format("%c",Code[11]);sscanf(s,"%u",&n);
		p=p+n;
	}
	n=p*3+i;
	//Ramener n  la dizaine suprieure
	short diz;
	diz=n/10;
	if (diz*10==n)
	{
		k=0;
	}
	else
	{
		diz=10+diz*10;
		k=diz-n;
	}
	return k;
}
