// PorSe1Dlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "PorSe1Dlg.h"
#include "BkDoc.h"
#include "Instek.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CPorSe1Dlg dialog
CPorSe1Dlg::CPorSe1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPorSe1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPorSe1Dlg)
	m_sTexte = _T("");
	m_radioPortSerie = -1;
	//}}AFX_DATA_INIT
}
void CPorSe1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPorSe1Dlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDTEST, m_btnTest);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Radio(pDX, IDC_COM1, m_radioPortSerie);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CPorSe1Dlg, CDialog)
	//{{AFX_MSG_MAP(CPorSe1Dlg)
	ON_BN_CLICKED(IDTEST, OnTest)
	ON_BN_CLICKED(IDC_COM1, OnCom1)
	ON_BN_CLICKED(IDC_COM2, OnCom2)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CPorSe1Dlg message handlers
BOOL CPorSe1Dlg::OnInitDialog() 
{
	m_radioPortSerie=m_pDoc->m_radioPortSerie;
	m_pInstek=new CInstek(m_radioPortSerie);
	m_sTexte.Format("Cliquer sur Tester pour valider la communication avec l'oscilloscope...");
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CPorSe1Dlg::OnCancel() 
{
	delete m_pInstek;
	CDialog::OnCancel();
}
//________________________________________
void CPorSe1Dlg::OnOK() 
{
	delete m_pInstek;
	UpdateData(TRUE);
	m_pDoc->m_radioPortSerie=m_radioPortSerie;
	CDialog::OnOK();
}
//________________________________________
void CPorSe1Dlg::OnTest() 
{
	UpdateData(TRUE);
	//Demande de la version de l'appareil
	m_pInstek->WriteCom("*CLS?\n");
	m_pInstek->WriteCom("*IDN?\n");

	m_btnTest.EnableWindow(FALSE);
	m_iNb=0;SetTimer(1,10,NULL);
}
//________________________________________
void CPorSe1Dlg::OnCom1() 
{
	KillTimer(1);
	delete m_pInstek;
	UpdateData(TRUE);
	m_pInstek=new CInstek(m_radioPortSerie);
}
//________________________________________
void CPorSe1Dlg::OnCom2() 
{
	KillTimer(1);
	delete m_pInstek;
	UpdateData(TRUE);
	m_pInstek=new CInstek(m_radioPortSerie);
}
//________________________________________
void CPorSe1Dlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	//Demande identification
	if (m_pDoc->m_OKOuvert)
	{
		//L'acquisition est en cours, on attend
		m_iNb=0;
	}
	else
	{
		m_iNb++;
		if (m_iNb>50)
		{
			KillTimer(1);
			m_btnTest.EnableWindow(TRUE);
			//On lit le buffer
			s=m_pInstek->Renvoi_buffer();
			if (s.IsEmpty())
			{
				m_sTexte.Format("Erreur de lecture sur COM%d.",m_radioPortSerie+1);
				m_btnOK.EnableWindow(FALSE);
			}
			else
			{
				m_btnOK.EnableWindow(TRUE);
				m_sTexte.Format("Identification:\n%s",s);
				//m_pDoc->m_iNbCar=0;
			}
		}
		UpdateData(FALSE);
	}		
	CDialog::OnTimer(nIDEvent);
}
