// RegDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "RegDlg.h"
#include "BkDoc.h"
#include "Regres.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CRegDlg dialog
CRegDlg::CRegDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRegDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRegDlg)
	m_radioNo = -1;
	m_sTexte = _T("");
	m_OKTrace = FALSE;
	m_sA0 = _T("");
	m_sA1 = _T("");
	m_sA2 = _T("");
	m_sA3 = _T("");
	m_sA4 = _T("");
	m_sA5 = _T("");
	m_sA6 = _T("");
	m_sA7 = _T("");
	m_fEcart = 0.0f;
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_REGRESSION,pParent);
}
void CRegDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegDlg)
	DDX_Control(pDX, IDCALCUL, m_btnCalculer);
	DDX_Control(pDX, IDC_COMBO1, m_ordreDeroul);
	DDX_Radio(pDX, IDC_REG0, m_radioNo);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Check(pDX, IDC_TRACE, m_OKTrace);
	DDX_Text(pDX, IDC_STATIC_A0, m_sA0);
	DDX_Text(pDX, IDC_STATIC_A1, m_sA1);
	DDX_Text(pDX, IDC_STATIC_A2, m_sA2);
	DDX_Text(pDX, IDC_STATIC_A3, m_sA3);
	DDX_Text(pDX, IDC_STATIC_A4, m_sA4);
	DDX_Text(pDX, IDC_STATIC_A5, m_sA5);
	DDX_Text(pDX, IDC_STATIC_A6, m_sA6);
	DDX_Text(pDX, IDC_STATIC_A7, m_sA7);
	DDX_Text(pDX, IDC_ECART, m_fEcart);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CRegDlg, CDialog)
	//{{AFX_MSG_MAP(CRegDlg)
	ON_BN_CLICKED(IDPT1, OnPt1)
	ON_BN_CLICKED(IDPT2, OnPt2)
	ON_BN_CLICKED(IDCALCUL, OnCalcul)
	ON_BN_CLICKED(IDC_REG0, OnReg0)
	ON_BN_CLICKED(IDC_REG1, OnReg1)
	ON_BN_CLICKED(IDC_REG2, OnReg2)
	ON_BN_CLICKED(IDC_TRACE, OnTrace)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CRegDlg message handlers
void CRegDlg::PostNcDestroy()
{
	delete this;
}
//__________________________________________________
void CRegDlg::OnOK() 
{
	//Bouton invalide
	//CDialog::OnOK();
}
//__________________________________________________
void CRegDlg::OnCancel() 
{
	CWnd* pParent=GetParent();
	CMenu* pMenu=pParent->GetMenu();
	//On peut maintenant re-ouvrir une bote de dialogue
	m_pDoc->m_OKReg=FALSE;                         
	//On dcoche la rubrique du menu
	pMenu->CheckMenuItem(ID_REGRESSION,MF_UNCHECKED);
  UpdateData(TRUE);
	if (m_fEcart<0.01) m_fEcart=0.01;
	m_pDoc->m_pReg->m_fEcart=m_fEcart;
	//Affectation n rgression par dfaut
	m_pDoc->m_pReg->m_radioNo=m_radioNo;
	CBkApp* pApp=(CBkApp*)AfxGetApp();
	//Pas de marque de pointage, pas de coordonnes relatives
	pApp->m_fDx=1e10;
	pApp->m_fDy=1e10;

	m_pDoc->UpdateAllViews(NULL);

	CDialog::OnCancel();
}
//__________________________________________________
void CRegDlg::AffecteS(CString s)
{
	GetDlgItem(IDC_STATIC_TEXTE)->SetWindowText(s);
}
//__________________________________________________
void CRegDlg::Affecte(CBkDoc *pDoc)
{
	short i;
	CString s;
	
	m_pDoc=pDoc;
	//N de la rgression [0, 2]
	m_radioNo=m_pDoc->m_pReg->m_radioNo;
	//Message utilisateur
	m_sTexte="Cliquez sur Point1 et Point2 pour slectioner 2 points appartenant  la mme courbe";
	m_OKTrace=m_pDoc->m_pReg->m_OKTrace[m_radioNo];
	//Affichage coefficients
	EcritCoef();
	//Ordre de la rgression linaire
	m_ordreDeroul.AddString("Rgression linaire");
	m_ordreDeroul.AddString("Polynomiale d'ordre 2");
	m_ordreDeroul.AddString("Polynomiale d'ordre 3");
	m_ordreDeroul.AddString("Polynomiale d'ordre 4");
	m_ordreDeroul.AddString("Polynomiale d'ordre 5");
	m_ordreDeroul.AddString("Polynomiale d'ordre 6");
	m_ordreDeroul.AddString("Polynomiale d'ordre 7");
	i=m_ordreDeroul.GetCount();
	if (i>=0)
	{
		m_ordreDeroul.GetLBText(m_pDoc->m_pReg->m_iType[m_radioNo],s);
		m_ordreDeroul.SetWindowText(s);	
	}
	if (!m_pDoc->m_pReg->m_OKPt[m_radioNo][0] && !m_pDoc->m_pReg->m_OKPt[m_radioNo][1])
		m_btnCalculer.EnableWindow(FALSE);

	m_fEcart=m_pDoc->m_pReg->m_fEcart;
  UpdateData(FALSE);
}
//__________________________________________________
void CRegDlg::EcritCoef(void)
{
	if (m_pDoc->m_pReg->m_fa[m_radioNo][0]!=1e10)
	{
		m_sA0.Format("a0:%9.3e",m_pDoc->m_pReg->m_fa[m_radioNo][0]);
	}
	else
	{
		m_sA0="a0=?";
	}
	if (m_pDoc->m_pReg->m_fa[m_radioNo][1]!=1e10)
	{
		m_sA1.Format("a1:%9.3e",m_pDoc->m_pReg->m_fa[m_radioNo][1]);
	}
	else
	{
		m_sA1="a1=?";
	}
	if (m_pDoc->m_pReg->m_fa[m_radioNo][2]!=1e10)
	{
		m_sA2.Format("a2:%9.3e",m_pDoc->m_pReg->m_fa[m_radioNo][2]);
	}
	else
	{
		m_sA2="a2=?";
	}
	if (m_pDoc->m_pReg->m_fa[m_radioNo][3]!=1e10)
	{
		m_sA3.Format("a3:%9.3e",m_pDoc->m_pReg->m_fa[m_radioNo][3]);
	}
	else
	{
		m_sA3="a3=?";
	}
	if (m_pDoc->m_pReg->m_fa[m_radioNo][4]!=1e10)
	{
		m_sA4.Format("a4:%9.3e",m_pDoc->m_pReg->m_fa[m_radioNo][4]);
	}
	else
	{
		m_sA4="a4=?";
	}
	if (m_pDoc->m_pReg->m_fa[m_radioNo][5]!=1e10)
	{
		m_sA5.Format("a5:%9.3e",m_pDoc->m_pReg->m_fa[m_radioNo][5]);
	}
	else
	{
		m_sA5="a5=?";
	}
	if (m_pDoc->m_pReg->m_fa[m_radioNo][6]!=1e10)
	{
		m_sA6.Format("a6:%9.3e",m_pDoc->m_pReg->m_fa[m_radioNo][6]);
	}
	else
	{
		m_sA6="a6=?";
	}
	if (m_pDoc->m_pReg->m_fa[m_radioNo][7]!=1e10)
	{
		m_sA7.Format("a7:%9.3e",m_pDoc->m_pReg->m_fa[m_radioNo][7]);
	}
	else
	{
		m_sA7="a7=?";
	}
}
//__________________________________________________
void CRegDlg::OnPt1() 
{
	//Premier point de la DMC
	UpdateData(TRUE); 
	if (m_fEcart<0.01) m_fEcart=0.01;
	UpdateData(FALSE); 
	m_pDoc->m_pReg->m_fEcart=m_fEcart;

	m_pDoc->m_pReg->m_iNoBtn[m_radioNo]=1;//Clic souris devient actif -> bkview.cpp
	m_pDoc->m_pReg->m_radioNo=m_radioNo;
  AffecteS("Placer le curseur de la souris sur le 1er point de la rgression.\r\nCliquez sur le bouton gauche.");
}
//__________________________________________________
void CRegDlg::OnPt2() 
{
	UpdateData(TRUE); 
	if (m_fEcart<0.01) m_fEcart=0.01;
	UpdateData(FALSE); 
	m_pDoc->m_pReg->m_fEcart=m_fEcart;
	m_pDoc->m_pReg->m_iNoBtn[m_radioNo]=2;//Clic souris devient actif -> bkview.cpp
	m_pDoc->m_pReg->m_radioNo=m_radioNo;
  AffecteS("Placer le curseur de la souris sur le 2me point de la rgression.\r\nCliquez sur le bouton gauche.");
}
//__________________________________________________
void CRegDlg::OnReg0() 
{
	CString s;
	m_radioNo=0;
	m_pDoc->m_pReg->m_radioNo=0;
	EcritCoef();
	m_OKTrace=m_pDoc->m_pReg->m_OKTrace[m_radioNo];
	m_ordreDeroul.GetLBText(m_pDoc->m_pReg->m_iType[m_radioNo],s);
	m_ordreDeroul.SetWindowText(s);	
	if (!m_pDoc->m_pReg->m_OKPt[m_radioNo][0] && !m_pDoc->m_pReg->m_OKPt[m_radioNo][1])
		m_btnCalculer.EnableWindow(FALSE);
	else
		m_btnCalculer.EnableWindow(TRUE);
	UpdateData(FALSE);
}
//__________________________________________________
void CRegDlg::OnReg1() 
{
	CString s;
	m_radioNo=1;
	m_pDoc->m_pReg->m_radioNo=1;
	EcritCoef();
	m_OKTrace=m_pDoc->m_pReg->m_OKTrace[m_radioNo];
	m_ordreDeroul.GetLBText(m_pDoc->m_pReg->m_iType[m_radioNo],s);
	m_ordreDeroul.SetWindowText(s);	
	if (!m_pDoc->m_pReg->m_OKPt[m_radioNo][0] && !m_pDoc->m_pReg->m_OKPt[m_radioNo][1])
		m_btnCalculer.EnableWindow(FALSE);
	else
		m_btnCalculer.EnableWindow(TRUE);
	UpdateData(FALSE);
}
//__________________________________________________
void CRegDlg::OnReg2() 
{
	CString s;
	m_radioNo=2;
	m_pDoc->m_pReg->m_radioNo=2;
	EcritCoef();
	m_OKTrace=m_pDoc->m_pReg->m_OKTrace[m_radioNo];
	m_ordreDeroul.GetLBText(m_pDoc->m_pReg->m_iType[m_radioNo],s);
	m_ordreDeroul.SetWindowText(s);	
	if (!m_pDoc->m_pReg->m_OKPt[m_radioNo][0] && !m_pDoc->m_pReg->m_OKPt[m_radioNo][1])
		m_btnCalculer.EnableWindow(FALSE);
	else
		m_btnCalculer.EnableWindow(TRUE);
	UpdateData(FALSE);
}
//__________________________________________________
void CRegDlg::OnTrace() 
{
	UpdateData(TRUE);
	if (m_OKTrace) m_pDoc->m_pReg->m_OKTrace[m_radioNo]=TRUE; else m_pDoc->m_pReg->m_OKTrace[m_radioNo]=FALSE;
}
//__________________________________________________
void CRegDlg::OnSelchangeCombo1() 
{
	UpdateData(TRUE);
	//Dfinition de l'ordre de la rgression
	m_pDoc->m_pReg->m_iType[m_radioNo]=m_ordreDeroul.GetCurSel();
}
//__________________________________________________
void CRegDlg::OnCalcul() 
{
	double 
		Q[8],	//Solution rgression polynomiale jusqu' l'ordre 7
		x,y;
  short
		iP1,iP2,
		jP1,jP2,
		n1,n2,
  	nb,
  	k;
	CString s;
	BOOL ok;

	//Les deux points ont t slectionns, on peut calculer les coef. de la dmc
  iP1=m_pDoc->m_pReg->m_iNoColX[m_radioNo][0];//Point P1
  iP2=m_pDoc->m_pReg->m_iNoColX[m_radioNo][1];//Point P2
  jP1=m_pDoc->m_pReg->m_iNoColY[m_radioNo][0];//Point P1
  jP2=m_pDoc->m_pReg->m_iNoColY[m_radioNo][1];//Point P2
  if (m_pDoc->m_pReg->m_iNoPt[m_radioNo][0]<m_pDoc->m_pReg->m_iNoPt[m_radioNo][1])
  {
  	n1=m_pDoc->m_pReg->m_iNoPt[m_radioNo][0];
  	n2=m_pDoc->m_pReg->m_iNoPt[m_radioNo][1];
  }
  else
  {
  	n2=m_pDoc->m_pReg->m_iNoPt[m_radioNo][0];
  	n1=m_pDoc->m_pReg->m_iNoPt[m_radioNo][1];
  }          
  if (n1!=n2 && iP1==iP2 && jP1==jP2)
  {
		//1.Dclaration d'un tableau de valeurs
		double (*m_fT)[2];
		m_fT=new double[n2-n1+1][2];
		s.Format("Calcul de la rgression d'ordre %d en cours sur %d valeurs...\n[%d][%d]",m_pDoc->m_pReg->m_iType[m_radioNo]+1,n2-n1+1,iP1,jP1);
		AffecteS(s);
		Sleep(300);
		//Pts d'indice i diffrents et appartenant  la mme courbe
		nb=0;
		for (k=n1;k<=n2;k++)
		{
			x=m_pDoc->m_fT[k][iP1];
			y=m_pDoc->m_fT[k][jP1];
			if (x!=1e10 && y!=1e10)
			{
				//2.Affectation avec valeurs x et y
				m_fT[nb][0]=x;
				m_fT[nb][1]=y;
				nb++;
				//s.Format("%d, %f, %f",nb-1,x*m_pDoc->m_fFactx,y*m_pDoc->m_fFacty);
				//AfxMessageBox(s);
			}
		}
		//3.Calcul regression
		ok=m_pDoc->m_pReg->CalculRegres(m_fT,nb,m_pDoc->m_pReg->m_iType[m_radioNo]+1,Q);
		//4.Affichage rsultat
		if (!ok)
		{
			m_sTexte="Le calcul de la rgression a chou !";
			m_pDoc->m_pReg->m_OKCalcul[m_radioNo]=FALSE;
			//5.Affectation coefficients
			for (k=0;k<8;k++)
			{
				m_pDoc->m_pReg->m_fa[m_radioNo][k]=1e10;
			}	
		}
		else
		{
			m_sTexte="Cliquer sur Fermer pour visualiser la courbe de rgression";
			m_pDoc->m_pReg->m_OKCalcul[m_radioNo]=TRUE;
			//5.Affectation coefficients
			for (k=0;k<8;k++)
			{
				m_pDoc->m_pReg->m_fa[m_radioNo][k]=Q[k];
			}	
		}
		EcritCoef();
		UpdateData(FALSE);
		//6.Suppression tableau de valeurs
		delete m_fT;
	}
}
